/* Resource description for DynaRamps application */

#include "Types.r"
#include "SysTypes.r"

Include "DynaRampSounds" 'snd ';

resource 'WIND' (128,preload) {
	{51, 4, 181, 224},
	documentProc,
	visible,
	GoAway,
	0x0,
	"DynaRamps"
};

resource 'MENU' (128, preload) {
	128,
	textMenuProc,
	0x7FFFFFFD,
	enabled,
	apple,
	{	/* array: 2 elements */
		/* [1] */
		"About DynaRamps", noIcon, "", "", plain,
		/* [2] */
		"-", noIcon, "", "", plain
	}
};

resource 'MENU' (129, preload) {
	129,
	textMenuProc,
	0x7FFFFFFB,
	enabled,
	"File",
	{	/* array: 4 elements */
		/* [1] */
		"Save PICT as", noIcon, "", "", plain,
		/* [2] */
		"Save Dithered PICT as", noIcon, "", "", plain,
		/* [3] */
		"-", noIcon, "", "", plain,
		/* [4] */
		"Quit", noIcon, "Q", "", plain
	}
};

resource 'MENU' (130, preload) {
	130,
	textMenuProc,
	0x7FFFFFFD,
	enabled,
	"Edit",
	{	/* array: 6 elements */
		/* [1] */
		"Undo", noIcon, "Z", "", plain,
		/* [2] */
		"-", noIcon, "", "", plain,
		/* [3] */
		"Cut", noIcon, "X", "", plain,
		/* [4] */
		"Copy", noIcon, "C", "", plain,
		/* [5] */
		"Paste", noIcon, "V", "", plain,
		/* [6] */
		"Clear", noIcon, "", "", plain
	}
};

resource 'MENU' (131, preload) {
	131,
	textMenuProc,
	0x7FFFFFFF,
	enabled,
	"Screens",
	{	/* array: 0 elements */
	}
};

resource 'MENU' (132, preload) {
	132,
	textMenuProc,
	0x7FFFF77F,
	enabled,
	"Buffer Fills",
	{	/* array: 15 elements */
		/* [1] */
		"GrayRamps", noIcon, "", "", plain,
		/* [2] */
		"Fixed Color", noIcon, "", "", plain,
		/* [3] */
		"JP demo ramp", noIcon, "", "", plain,
		/* [4] */
		"Corner color spread", noIcon, "", "", plain,
		/* [5] */
		"Snake pattern", noIcon, "", "", plain,
		/* [6] */
		"Circles of hue", noIcon, "", "", plain,
		/* [7] */
		"Spectrum spread", noIcon, "", "", plain,
		/* [8] */
		"-", noIcon, "", "", plain,
		/* [9] */
		"Fill Alpha With 0x7F", noIcon, "", "", plain,
		/* [10] */
		"Fill Alpha With Circle", noIcon, "", "", plain,
		/* [11] */
		"Alpha Blast", noIcon, "", "", plain,
		/* [12] */
		"-", noIcon, "", "", plain,
		/* [13] */
		"Color Ramp Cycling", noIcon, "", "", plain,
		/* [14] */
		"Color Ramp OverFlows", noIcon, "", "", plain,
		/* [15] */
		"Color Ramp Restore", noIcon, "", "", plain
	}
};

resource 'MENU' (134, preload) {
	134,
	textMenuProc,
	0x7FFFFFF3,
	enabled,
	"Configure",
	{	/* array: 4 elements */
		/* [1] */
		"Dither Look Window", noIcon, "", "", plain,
		/* [2] */
		"Look Window Palette", noIcon, hierarchicalMenu, "\0D135", plain,
		/* [3] */
		"Configure Alpha Circle", noIcon, "", "", plain,
		/* [4] */
		"Configure Alpha Holes", noIcon, "", "", plain
	}
};

resource 'MENU' (135, preload) {
	135,
	textMenuProc,
	0x7FFFFFFF,
	enabled,
	"Palette",
	{	/* array: 4 elements */
		/* [1] */
		"  256 system colors", noIcon, "", "", plain,
		/* [2] */
		"  Rainbows", noIcon, "", "", plain,
		/* [3] */
		"  332", noIcon, "", "", plain,
		/* [4] */
		"  256 grays", noIcon, "", "", plain
	}
};


resource 'DLOG' (128, purgeable, preload) {
	{40, 10, 200, 370},
	altDBoxProc,
	invisible,
	noGoAway,
	0x0,
	128,
	"About DynaRamps Dialog"
};

resource 'DITL' (128, purgeable, preload) {
	{	/* array DITLarray: 2 elements */
		/* [1] */
		{0, 0, 999, 999},
		StaticText {
			enabled,
			""
		},
		/* [2] */
		{16, 28, 166, 360},
		StaticText {
			disabled,
			"DynaRamps\n\n"
			"Portions  1989, 1990 ICOM Simulations, Inc.\n"
			"Written by Jay Zipnick\n\n\n"
			"Version 2.1d2\n"
			"Not for commercial distribution."
		},
	}
};

resource 'ALRT' (130) {
	{40, 40, 240, 280},
	130,
	{	/* array: 4 elements */
		/* [1] */
		OK, visible, sound1,
		/* [2] */
		OK, visible, sound1,
		/* [3] */
		OK, visible, sound1,
		/* [4] */
		OK, visible, sound1
	}
};

resource 'DITL' (130) {
	{	/* array DITLarray: 2 elements */
		/* [1] */
		{164, 90, 184, 150},
		Button {
			enabled,
			"Quit"
		},
		/* [2] */
		{20, 12, 157, 233},
		StaticText {
			disabled,
			"In the past, dinosaurs roamed the earth,"
			" man lived in caves, and Macintosh users"
			" had pre-System 6.0.5 software.\n\nYou are"
			" living in the past. This software requi"
			"res System 6.0.5 or newer.\n"
		}
	}
};

resource 'CURS' (128) {
	$"03 80 02 80 02 80 02 80 02 80 02 80 FE FE 80 02"
	$"FE FE 02 80 02 80 02 80 02 80 02 80 03 80",
	$"07 C0 06 C0 06 C0 06 C0 06 C0 FA BE FE FE 80 02"
	$"FE FE FA BE 06 C0 06 C0 06 C0 06 C0 07 C0",
	{7, 7}
};

resource 'clut' (512, "Rainbow") {
	0,
	0x8000,
	{	/* array ColorSpec: 256 elements */
		0, 65535, 65535, 65535,
		0, 0, 26880, 65280,
		0, 0, 25344, 65280,
		0, 0, 23808, 65280,
		0, 0, 22016, 65280,
		0, 0, 20480, 65280,
		0, 0, 18944, 65280,
		0, 0, 17152, 65280,
		0, 0, 15616, 65280,
		0, 0, 13824, 65280,
		0, 0, 12288, 65280,
		0, 0, 10752, 65280,
		0, 0, 8960, 65280,
		0, 0, 7424, 65280,
		0, 0, 5888, 65280,
		0, 0, 4096, 65280,
		0, 0, 2560, 65280,
		0, 0, 768, 65280,
		0, 1536, 0, 65280,
		0, 3072, 0, 65280,
		0, 4864, 0, 65280,
		0, 6400, 0, 65280,
		0, 7936, 0, 65280,
		0, 9728, 0, 65280,
		0, 11264, 0, 65280,
		0, 13056, 0, 65280,
		0, 14592, 0, 65280,
		0, 16128, 0, 65280,
		0, 17920, 0, 65280,
		0, 19456, 0, 65280,
		0, 20992, 0, 65280,
		0, 22784, 0, 65280,
		0, 24320, 0, 65280,
		0, 26112, 0, 65280,
		0, 27648, 0, 65280,
		0, 29184, 0, 65280,
		0, 30976, 0, 65280,
		0, 32512, 0, 65280,
		0, 34048, 0, 65280,
		0, 35840, 0, 65280,
		0, 37376, 0, 65280,
		0, 39168, 0, 65280,
		0, 40704, 0, 65280,
		0, 42240, 0, 65280,
		0, 44032, 0, 65280,
		0, 45568, 0, 65280,
		0, 47104, 0, 65280,
		0, 48896, 0, 65280,
		0, 50432, 0, 65280,
		0, 52224, 0, 65280,
		0, 53760, 0, 65280,
		0, 55296, 0, 65280,
		0, 57088, 0, 65280,
		0, 58624, 0, 65280,
		0, 60160, 0, 65280,
		0, 61952, 0, 65280,
		0, 63488, 0, 65280,
		0, 65280, 0, 65280,
		0, 65280, 0, 63488,
		0, 65280, 0, 61952,
		0, 65280, 0, 60160,
		0, 65280, 0, 58624,
		0, 65280, 0, 57088,
		0, 65280, 0, 55296,
		0, 65280, 0, 53760,
		0, 65280, 0, 52224,
		0, 65280, 0, 50432,
		0, 65280, 0, 48896,
		0, 65280, 0, 47104,
		0, 65280, 0, 45568,
		0, 65280, 0, 44032,
		0, 65280, 0, 42240,
		0, 65280, 0, 40704,
		0, 65280, 0, 39168,
		0, 65280, 0, 37376,
		0, 65280, 0, 35840,
		0, 65280, 0, 34048,
		0, 65280, 0, 32512,
		0, 65280, 0, 30976,
		0, 65280, 0, 29184,
		0, 65280, 0, 27648,
		0, 65280, 0, 26112,
		0, 65280, 0, 24320,
		0, 65280, 0, 22784,
		0, 65280, 0, 20992,
		0, 65280, 0, 19456,
		0, 65280, 0, 17920,
		0, 65280, 0, 16128,
		0, 65280, 0, 14592,
		0, 65280, 0, 13056,
		0, 65280, 0, 11264,
		0, 65280, 0, 9728,
		0, 65280, 0, 7936,
		0, 65280, 0, 6400,
		0, 65280, 0, 4864,
		0, 65280, 0, 3072,
		0, 65280, 0, 1536,
		0, 65280, 0, 0,
		0, 65280, 1536, 0,
		0, 65280, 3072, 0,
		0, 65280, 4864, 0,
		0, 65280, 6400, 0,
		0, 65280, 7936, 0,
		0, 65280, 9728, 0,
		0, 65280, 11264, 0,
		0, 65280, 13056, 0,
		0, 65280, 14592, 0,
		0, 65280, 16128, 0,
		0, 65280, 17920, 0,
		0, 65280, 19456, 0,
		0, 65280, 20992, 0,
		0, 65280, 22784, 0,
		0, 65280, 24320, 0,
		0, 65280, 26112, 0,
		0, 65280, 27648, 0,
		0, 65280, 29184, 0,
		0, 65280, 30976, 0,
		0, 65280, 32512, 0,
		0, 65280, 34048, 0,
		0, 65280, 35840, 0,
		0, 65280, 37376, 0,
		0, 65280, 39168, 0,
		0, 65280, 40704, 0,
		0, 65280, 42240, 0,
		0, 65280, 44032, 0,
		0, 65280, 45568, 0,
		0, 65280, 47104, 0,
		0, 65280, 48896, 0,
		0, 65280, 50432, 0,
		0, 65280, 52224, 0,
		0, 65280, 53760, 0,
		0, 65280, 55296, 0,
		0, 65280, 57088, 0,
		0, 65280, 58624, 0,
		0, 65280, 60160, 0,
		0, 65280, 61952, 0,
		0, 65280, 63488, 0,
		0, 65280, 65280, 0,
		0, 63488, 65280, 0,
		0, 61952, 65280, 0,
		0, 60160, 65280, 0,
		0, 58624, 65280, 0,
		0, 57088, 65280, 0,
		0, 55296, 65280, 0,
		0, 53760, 65280, 0,
		0, 52224, 65280, 0,
		0, 50432, 65280, 0,
		0, 48896, 65280, 0,
		0, 47104, 65280, 0,
		0, 45568, 65280, 0,
		0, 44032, 65280, 0,
		0, 42240, 65280, 0,
		0, 40704, 65280, 0,
		0, 39168, 65280, 0,
		0, 37376, 65280, 0,
		0, 35840, 65280, 0,
		0, 34048, 65280, 0,
		0, 32512, 65280, 0,
		0, 30976, 65280, 0,
		0, 29184, 65280, 0,
		0, 27648, 65280, 0,
		0, 26112, 65280, 0,
		0, 24320, 65280, 0,
		0, 22784, 65280, 0,
		0, 20992, 65280, 0,
		0, 19456, 65280, 0,
		0, 17920, 65280, 0,
		0, 16128, 65280, 0,
		0, 14592, 65280, 0,
		0, 13056, 65280, 0,
		0, 11264, 65280, 0,
		0, 9728, 65280, 0,
		0, 7936, 65280, 0,
		0, 6400, 65280, 0,
		0, 4864, 65280, 0,
		0, 3072, 65280, 0,
		0, 1536, 65280, 0,
		0, 0, 65280, 0,
		0, 0, 65280, 1536,
		0, 0, 65280, 3072,
		0, 0, 65280, 4864,
		0, 0, 65280, 6400,
		0, 0, 65280, 7936,
		0, 0, 65280, 9728,
		0, 0, 65280, 11264,
		0, 0, 65280, 13056,
		0, 0, 65280, 14592,
		0, 0, 65280, 16128,
		0, 0, 65280, 17920,
		0, 0, 65280, 19456,
		0, 0, 65280, 20992,
		0, 0, 65280, 22784,
		0, 0, 65280, 24320,
		0, 0, 65280, 26112,
		0, 0, 65280, 27648,
		0, 0, 65280, 29184,
		0, 0, 65280, 30976,
		0, 0, 65280, 32512,
		0, 0, 65280, 34048,
		0, 0, 65280, 35840,
		0, 0, 65280, 37376,
		0, 0, 65280, 39168,
		0, 0, 65280, 40704,
		0, 0, 65280, 42240,
		0, 0, 65280, 44032,
		0, 0, 65280, 45568,
		0, 0, 65280, 47104,
		0, 0, 65280, 48896,
		0, 0, 65280, 50432,
		0, 0, 65280, 52224,
		0, 0, 65280, 53760,
		0, 0, 65280, 55296,
		0, 0, 65280, 57088,
		0, 0, 65280, 58624,
		0, 0, 65280, 60160,
		0, 0, 65280, 61952,
		0, 0, 65280, 63488,
		0, 0, 65280, 65280,
		0, 0, 63488, 65280,
		0, 0, 61952, 65280,
		0, 0, 60160, 65280,
		0, 0, 58624, 65280,
		0, 0, 57088, 65280,
		0, 0, 55296, 65280,
		0, 0, 53760, 65280,
		0, 0, 52224, 65280,
		0, 0, 50432, 65280,
		0, 0, 48896, 65280,
		0, 0, 47104, 65280,
		0, 0, 45568, 65280,
		0, 0, 44032, 65280,
		0, 0, 42240, 65280,
		0, 0, 40704, 65280,
		0, 0, 39168, 65280,
		0, 0, 37376, 65280,
		0, 0, 35840, 65280,
		0, 0, 34048, 65280,
		0, 0, 32512, 65280,
		0, 0, 30976, 65280,
		0, 0, 29184, 65280,
		0, 61440, 61440, 61440,
		0, 57344, 57344, 57344,
		0, 53248, 53248, 53248,
		0, 49152, 49152, 49152,
		0, 45056, 45056, 45056,
		0, 40960, 40960, 40960,
		0, 36864, 36864, 36864,
		0, 32768, 32768, 32768,
		0, 28672, 28672, 28672,
		0, 24576, 24576, 24576,
		0, 20480, 20480, 20480,
		0, 16384, 16384, 16384,
		0, 12288, 12288, 12288,
		0, 8192, 8192, 8192,
		0, 4096, 4096, 4096,
		0, 0, 0, 0
	}
};

resource 'clut' (513, "332") {
	0,
	-32768,
	{	/* array ColorSpec: 256 elements */
		0,$FFFF,$FFFF,$FFFF,
		0,$FFFF,$FFFF,$AAAA,
		0,$FFFF,$FFFF,$5555,
		0,$FFFF,$FFFF,$0000,
		0,$FFFF,$DADA,$FFFF,
		0,$FFFF,$DADA,$AAAA,
		0,$FFFF,$DADA,$5555,
		0,$FFFF,$DADA,$0000,
		0,$FFFF,$B6B6,$FFFF,
		0,$FFFF,$B6B6,$AAAA,
		0,$FFFF,$B6B6,$5555,
		0,$FFFF,$B6B6,$0000,
		0,$FFFF,$9191,$FFFF,
		0,$FFFF,$9191,$AAAA,
		0,$FFFF,$9191,$5555,
		0,$FFFF,$9191,$0000,
		0,$FFFF,$6D6D,$FFFF,
		0,$FFFF,$6D6D,$AAAA,
		0,$FFFF,$6D6D,$5555,
		0,$FFFF,$6D6D,$0000,
		0,$FFFF,$4848,$FFFF,
		0,$FFFF,$4848,$AAAA,
		0,$FFFF,$4848,$5555,
		0,$FFFF,$4848,$0000,
		0,$FFFF,$2424,$FFFF,
		0,$FFFF,$2424,$AAAA,
		0,$FFFF,$2424,$5555,
		0,$FFFF,$2424,$0000,
		0,$FFFF,$0000,$FFFF,
		0,$FFFF,$0000,$AAAA,
		0,$FFFF,$0000,$5555,
		0,$FFFF,$0000,$0000,
		0,$DADA,$FFFF,$FFFF,
		0,$DADA,$FFFF,$AAAA,
		0,$DADA,$FFFF,$5555,
		0,$DADA,$FFFF,$0000,
		0,$DADA,$DADA,$FFFF,
		0,$DADA,$DADA,$AAAA,
		0,$DADA,$DADA,$5555,
		0,$DADA,$DADA,$0000,
		0,$DADA,$B6B6,$FFFF,
		0,$DADA,$B6B6,$AAAA,
		0,$DADA,$B6B6,$5555,
		0,$DADA,$B6B6,$0000,
		0,$DADA,$9191,$FFFF,
		0,$DADA,$9191,$AAAA,
		0,$DADA,$9191,$5555,
		0,$DADA,$9191,$0000,
		0,$DADA,$6D6D,$FFFF,
		0,$DADA,$6D6D,$AAAA,
		0,$DADA,$6D6D,$5555,
		0,$DADA,$6D6D,$0000,
		0,$DADA,$4848,$FFFF,
		0,$DADA,$4848,$AAAA,
		0,$DADA,$4848,$5555,
		0,$DADA,$4848,$0000,
		0,$DADA,$2424,$FFFF,
		0,$DADA,$2424,$AAAA,
		0,$DADA,$2424,$5555,
		0,$DADA,$2424,$0000,
		0,$DADA,$0000,$FFFF,
		0,$DADA,$0000,$AAAA,
		0,$DADA,$0000,$5555,
		0,$DADA,$0000,$0000,
		0,$B6B6,$FFFF,$FFFF,
		0,$B6B6,$FFFF,$AAAA,
		0,$B6B6,$FFFF,$5555,
		0,$B6B6,$FFFF,$0000,
		0,$B6B6,$DADA,$FFFF,
		0,$B6B6,$DADA,$AAAA,
		0,$B6B6,$DADA,$5555,
		0,$B6B6,$DADA,$0000,
		0,$B6B6,$B6B6,$FFFF,
		0,$B6B6,$B6B6,$AAAA,
		0,$B6B6,$B6B6,$5555,
		0,$B6B6,$B6B6,$0000,
		0,$B6B6,$9191,$FFFF,
		0,$B6B6,$9191,$AAAA,
		0,$B6B6,$9191,$5555,
		0,$B6B6,$9191,$0000,
		0,$B6B6,$6D6D,$FFFF,
		0,$B6B6,$6D6D,$AAAA,
		0,$B6B6,$6D6D,$5555,
		0,$B6B6,$6D6D,$0000,
		0,$B6B6,$4848,$FFFF,
		0,$B6B6,$4848,$AAAA,
		0,$B6B6,$4848,$5555,
		0,$B6B6,$4848,$0000,
		0,$B6B6,$2424,$FFFF,
		0,$B6B6,$2424,$AAAA,
		0,$B6B6,$2424,$5555,
		0,$B6B6,$2424,$0000,
		0,$B6B6,$0000,$FFFF,
		0,$B6B6,$0000,$AAAA,
		0,$B6B6,$0000,$5555,
		0,$B6B6,$0000,$0000,
		0,$9191,$FFFF,$FFFF,
		0,$9191,$FFFF,$AAAA,
		0,$9191,$FFFF,$5555,
		0,$9191,$FFFF,$0000,
		0,$9191,$DADA,$FFFF,
		0,$9191,$DADA,$AAAA,
		0,$9191,$DADA,$5555,
		0,$9191,$DADA,$0000,
		0,$9191,$B6B6,$FFFF,
		0,$9191,$B6B6,$AAAA,
		0,$9191,$B6B6,$5555,
		0,$9191,$B6B6,$0000,
		0,$9191,$9191,$FFFF,
		0,$9191,$9191,$AAAA,
		0,$9191,$9191,$5555,
		0,$9191,$9191,$0000,
		0,$9191,$6D6D,$FFFF,
		0,$9191,$6D6D,$AAAA,
		0,$9191,$6D6D,$5555,
		0,$9191,$6D6D,$0000,
		0,$9191,$4848,$FFFF,
		0,$9191,$4848,$AAAA,
		0,$9191,$4848,$5555,
		0,$9191,$4848,$0000,
		0,$9191,$2424,$FFFF,
		0,$9191,$2424,$AAAA,
		0,$9191,$2424,$5555,
		0,$9191,$2424,$0000,
		0,$9191,$0000,$FFFF,
		0,$9191,$0000,$AAAA,
		0,$9191,$0000,$5555,
		0,$9191,$0000,$0000,
		0,$6D6D,$FFFF,$FFFF,
		0,$6D6D,$FFFF,$AAAA,
		0,$6D6D,$FFFF,$5555,
		0,$6D6D,$FFFF,$0000,
		0,$6D6D,$DADA,$FFFF,
		0,$6D6D,$DADA,$AAAA,
		0,$6D6D,$DADA,$5555,
		0,$6D6D,$DADA,$0000,
		0,$6D6D,$B6B6,$FFFF,
		0,$6D6D,$B6B6,$AAAA,
		0,$6D6D,$B6B6,$5555,
		0,$6D6D,$B6B6,$0000,
		0,$6D6D,$9191,$FFFF,
		0,$6D6D,$9191,$AAAA,
		0,$6D6D,$9191,$5555,
		0,$6D6D,$9191,$0000,
		0,$6D6D,$6D6D,$FFFF,
		0,$6D6D,$6D6D,$AAAA,
		0,$6D6D,$6D6D,$5555,
		0,$6D6D,$6D6D,$0000,
		0,$6D6D,$4848,$FFFF,
		0,$6D6D,$4848,$AAAA,
		0,$6D6D,$4848,$5555,
		0,$6D6D,$4848,$0000,
		0,$6D6D,$2424,$FFFF,
		0,$6D6D,$2424,$AAAA,
		0,$6D6D,$2424,$5555,
		0,$6D6D,$2424,$0000,
		0,$6D6D,$0000,$FFFF,
		0,$6D6D,$0000,$AAAA,
		0,$6D6D,$0000,$5555,
		0,$6D6D,$0000,$0000,
		0,$4848,$FFFF,$FFFF,
		0,$4848,$FFFF,$AAAA,
		0,$4848,$FFFF,$5555,
		0,$4848,$FFFF,$0000,
		0,$4848,$DADA,$FFFF,
		0,$4848,$DADA,$AAAA,
		0,$4848,$DADA,$5555,
		0,$4848,$DADA,$0000,
		0,$4848,$B6B6,$FFFF,
		0,$4848,$B6B6,$AAAA,
		0,$4848,$B6B6,$5555,
		0,$4848,$B6B6,$0000,
		0,$4848,$9191,$FFFF,
		0,$4848,$9191,$AAAA,
		0,$4848,$9191,$5555,
		0,$4848,$9191,$0000,
		0,$4848,$6D6D,$FFFF,
		0,$4848,$6D6D,$AAAA,
		0,$4848,$6D6D,$5555,
		0,$4848,$6D6D,$0000,
		0,$4848,$4848,$FFFF,
		0,$4848,$4848,$AAAA,
		0,$4848,$4848,$5555,
		0,$4848,$4848,$0000,
		0,$4848,$2424,$FFFF,
		0,$4848,$2424,$AAAA,
		0,$4848,$2424,$5555,
		0,$4848,$2424,$0000,
		0,$4848,$0000,$FFFF,
		0,$4848,$0000,$AAAA,
		0,$4848,$0000,$5555,
		0,$4848,$0000,$0000,
		0,$2424,$FFFF,$FFFF,
		0,$2424,$FFFF,$AAAA,
		0,$2424,$FFFF,$5555,
		0,$2424,$FFFF,$0000,
		0,$2424,$DADA,$FFFF,
		0,$2424,$DADA,$AAAA,
		0,$2424,$DADA,$5555,
		0,$2424,$DADA,$0000,
		0,$2424,$B6B6,$FFFF,
		0,$2424,$B6B6,$AAAA,
		0,$2424,$B6B6,$5555,
		0,$2424,$B6B6,$0000,
		0,$2424,$9191,$FFFF,
		0,$2424,$9191,$AAAA,
		0,$2424,$9191,$5555,
		0,$2424,$9191,$0000,
		0,$2424,$6D6D,$FFFF,
		0,$2424,$6D6D,$AAAA,
		0,$2424,$6D6D,$5555,
		0,$2424,$6D6D,$0000,
		0,$2424,$4848,$FFFF,
		0,$2424,$4848,$AAAA,
		0,$2424,$4848,$5555,
		0,$2424,$4848,$0000,
		0,$2424,$2424,$FFFF,
		0,$2424,$2424,$AAAA,
		0,$2424,$2424,$5555,
		0,$2424,$2424,$0000,
		0,$2424,$0000,$FFFF,
		0,$2424,$0000,$AAAA,
		0,$2424,$0000,$5555,
		0,$2424,$0000,$0000,
		0,$0000,$FFFF,$FFFF,
		0,$0000,$FFFF,$AAAA,
		0,$0000,$FFFF,$5555,
		0,$0000,$FFFF,$0000,
		0,$0000,$DADA,$FFFF,
		0,$0000,$DADA,$AAAA,
		0,$0000,$DADA,$5555,
		0,$0000,$DADA,$0000,
		0,$0000,$B6B6,$FFFF,
		0,$0000,$B6B6,$AAAA,
		0,$0000,$B6B6,$5555,
		0,$0000,$B6B6,$0000,
		0,$0000,$9191,$FFFF,
		0,$0000,$9191,$AAAA,
		0,$0000,$9191,$5555,
		0,$0000,$9191,$0000,
		0,$0000,$6D6D,$FFFF,
		0,$0000,$6D6D,$AAAA,
		0,$0000,$6D6D,$5555,
		0,$0000,$6D6D,$0000,
		0,$0000,$4848,$FFFF,
		0,$0000,$4848,$AAAA,
		0,$0000,$4848,$5555,
		0,$0000,$4848,$0000,
		0,$0000,$2424,$FFFF,
		0,$0000,$2424,$AAAA,
		0,$0000,$2424,$5555,
		0,$0000,$2424,$0000,
		0,$0000,$0000,$FFFF,
		0,$0000,$0000,$AAAA,
		0,$0000,$0000,$5555,
		0,$0000,$0000,$0000
	}
};

resource 'clut' (514, "256 grays") {
	0,
	0x8000,
	{	/* array ColorSpec: 256 elements */
		0, 65535, 65535, 65535,
		0, 65278, 65278, 65278,
		0, 65021, 65021, 65021,
		0, 64764, 64764, 64764,
		0, 64507, 64507, 64507,
		0, 64250, 64250, 64250,
		0, 63993, 63993, 63993,
		0, 63736, 63736, 63736,
		0, 63479, 63479, 63479,
		0, 63222, 63222, 63222,
		0, 62965, 62965, 62965,
		0, 62708, 62708, 62708,
		0, 62451, 62451, 62451,
		0, 62194, 62194, 62194,
		0, 61937, 61937, 61937,
		0, 61680, 61680, 61680,
		0, 61423, 61423, 61423,
		0, 61166, 61166, 61166,
		0, 60909, 60909, 60909,
		0, 60652, 60652, 60652,
		0, 60395, 60395, 60395,
		0, 60138, 60138, 60138,
		0, 59881, 59881, 59881,
		0, 59624, 59624, 59624,
		0, 59367, 59367, 59367,
		0, 59110, 59110, 59110,
		0, 58853, 58853, 58853,
		0, 58596, 58596, 58596,
		0, 58339, 58339, 58339,
		0, 58082, 58082, 58082,
		0, 57825, 57825, 57825,
		0, 57568, 57568, 57568,
		0, 57311, 57311, 57311,
		0, 57054, 57054, 57054,
		0, 56797, 56797, 56797,
		0, 56540, 56540, 56540,
		0, 56283, 56283, 56283,
		0, 56026, 56026, 56026,
		0, 55769, 55769, 55769,
		0, 55512, 55512, 55512,
		0, 55255, 55255, 55255,
		0, 54998, 54998, 54998,
		0, 54741, 54741, 54741,
		0, 54484, 54484, 54484,
		0, 54227, 54227, 54227,
		0, 53970, 53970, 53970,
		0, 53713, 53713, 53713,
		0, 53456, 53456, 53456,
		0, 53199, 53199, 53199,
		0, 52942, 52942, 52942,
		0, 52685, 52685, 52685,
		0, 52428, 52428, 52428,
		0, 52171, 52171, 52171,
		0, 51914, 51914, 51914,
		0, 51657, 51657, 51657,
		0, 51400, 51400, 51400,
		0, 51143, 51143, 51143,
		0, 50886, 50886, 50886,
		0, 50629, 50629, 50629,
		0, 50372, 50372, 50372,
		0, 50115, 50115, 50115,
		0, 49858, 49858, 49858,
		0, 49601, 49601, 49601,
		0, 49344, 49344, 49344,
		0, 49087, 49087, 49087,
		0, 48830, 48830, 48830,
		0, 48573, 48573, 48573,
		0, 48316, 48316, 48316,
		0, 48059, 48059, 48059,
		0, 47802, 47802, 47802,
		0, 47545, 47545, 47545,
		0, 47288, 47288, 47288,
		0, 47031, 47031, 47031,
		0, 46774, 46774, 46774,
		0, 46517, 46517, 46517,
		0, 46260, 46260, 46260,
		0, 46003, 46003, 46003,
		0, 45746, 45746, 45746,
		0, 45489, 45489, 45489,
		0, 45232, 45232, 45232,
		0, 44975, 44975, 44975,
		0, 44718, 44718, 44718,
		0, 44461, 44461, 44461,
		0, 44204, 44204, 44204,
		0, 43947, 43947, 43947,
		0, 43690, 43690, 43690,
		0, 43433, 43433, 43433,
		0, 43176, 43176, 43176,
		0, 42919, 42919, 42919,
		0, 42662, 42662, 42662,
		0, 42405, 42405, 42405,
		0, 42148, 42148, 42148,
		0, 41891, 41891, 41891,
		0, 41634, 41634, 41634,
		0, 41377, 41377, 41377,
		0, 41120, 41120, 41120,
		0, 40863, 40863, 40863,
		0, 40606, 40606, 40606,
		0, 40349, 40349, 40349,
		0, 40092, 40092, 40092,
		0, 39835, 39835, 39835,
		0, 39578, 39578, 39578,
		0, 39321, 39321, 39321,
		0, 39064, 39064, 39064,
		0, 38807, 38807, 38807,
		0, 38550, 38550, 38550,
		0, 38293, 38293, 38293,
		0, 38036, 38036, 38036,
		0, 37779, 37779, 37779,
		0, 37522, 37522, 37522,
		0, 37265, 37265, 37265,
		0, 37008, 37008, 37008,
		0, 36751, 36751, 36751,
		0, 36494, 36494, 36494,
		0, 36237, 36237, 36237,
		0, 35980, 35980, 35980,
		0, 35723, 35723, 35723,
		0, 35466, 35466, 35466,
		0, 35209, 35209, 35209,
		0, 34952, 34952, 34952,
		0, 34695, 34695, 34695,
		0, 34438, 34438, 34438,
		0, 34181, 34181, 34181,
		0, 33924, 33924, 33924,
		0, 33667, 33667, 33667,
		0, 33410, 33410, 33410,
		0, 33153, 33153, 33153,
		0, 32896, 32896, 32896,
		0, 32639, 32639, 32639,
		0, 32382, 32382, 32382,
		0, 32125, 32125, 32125,
		0, 31868, 31868, 31868,
		0, 31611, 31611, 31611,
		0, 31354, 31354, 31354,
		0, 31097, 31097, 31097,
		0, 30840, 30840, 30840,
		0, 30583, 30583, 30583,
		0, 30326, 30326, 30326,
		0, 30069, 30069, 30069,
		0, 29812, 29812, 29812,
		0, 29555, 29555, 29555,
		0, 29298, 29298, 29298,
		0, 29041, 29041, 29041,
		0, 28784, 28784, 28784,
		0, 28527, 28527, 28527,
		0, 28270, 28270, 28270,
		0, 28013, 28013, 28013,
		0, 27756, 27756, 27756,
		0, 27499, 27499, 27499,
		0, 27242, 27242, 27242,
		0, 26985, 26985, 26985,
		0, 26728, 26728, 26728,
		0, 26471, 26471, 26471,
		0, 26214, 26214, 26214,
		0, 25957, 25957, 25957,
		0, 25700, 25700, 25700,
		0, 25443, 25443, 25443,
		0, 25186, 25186, 25186,
		0, 24929, 24929, 24929,
		0, 24672, 24672, 24672,
		0, 24415, 24415, 24415,
		0, 24158, 24158, 24158,
		0, 23901, 23901, 23901,
		0, 23644, 23644, 23644,
		0, 23387, 23387, 23387,
		0, 23130, 23130, 23130,
		0, 22873, 22873, 22873,
		0, 22616, 22616, 22616,
		0, 22359, 22359, 22359,
		0, 22102, 22102, 22102,
		0, 21845, 21845, 21845,
		0, 21588, 21588, 21588,
		0, 21331, 21331, 21331,
		0, 21074, 21074, 21074,
		0, 20817, 20817, 20817,
		0, 20560, 20560, 20560,
		0, 20303, 20303, 20303,
		0, 20046, 20046, 20046,
		0, 19789, 19789, 19789,
		0, 19532, 19532, 19532,
		0, 19275, 19275, 19275,
		0, 19018, 19018, 19018,
		0, 18761, 18761, 18761,
		0, 18504, 18504, 18504,
		0, 18247, 18247, 18247,
		0, 17990, 17990, 17990,
		0, 17733, 17733, 17733,
		0, 17476, 17476, 17476,
		0, 17219, 17219, 17219,
		0, 16962, 16962, 16962,
		0, 16705, 16705, 16705,
		0, 16448, 16448, 16448,
		0, 16191, 16191, 16191,
		0, 15934, 15934, 15934,
		0, 15677, 15677, 15677,
		0, 15420, 15420, 15420,
		0, 15163, 15163, 15163,
		0, 14906, 14906, 14906,
		0, 14649, 14649, 14649,
		0, 14392, 14392, 14392,
		0, 14135, 14135, 14135,
		0, 13878, 13878, 13878,
		0, 13621, 13621, 13621,
		0, 13364, 13364, 13364,
		0, 13107, 13107, 13107,
		0, 12850, 12850, 12850,
		0, 12593, 12593, 12593,
		0, 12336, 12336, 12336,
		0, 12079, 12079, 12079,
		0, 11822, 11822, 11822,
		0, 11565, 11565, 11565,
		0, 11308, 11308, 11308,
		0, 11051, 11051, 11051,
		0, 10794, 10794, 10794,
		0, 10537, 10537, 10537,
		0, 10280, 10280, 10280,
		0, 10023, 10023, 10023,
		0, 9766, 9766, 9766,
		0, 9509, 9509, 9509,
		0, 9252, 9252, 9252,
		0, 8995, 8995, 8995,
		0, 8738, 8738, 8738,
		0, 8481, 8481, 8481,
		0, 8224, 8224, 8224,
		0, 7967, 7967, 7967,
		0, 7710, 7710, 7710,
		0, 7453, 7453, 7453,
		0, 7196, 7196, 7196,
		0, 6939, 6939, 6939,
		0, 6682, 6682, 6682,
		0, 6425, 6425, 6425,
		0, 6168, 6168, 6168,
		0, 5911, 5911, 5911,
		0, 5654, 5654, 5654,
		0, 5397, 5397, 5397,
		0, 5140, 5140, 5140,
		0, 4883, 4883, 4883,
		0, 4626, 4626, 4626,
		0, 4369, 4369, 4369,
		0, 4112, 4112, 4112,
		0, 3855, 3855, 3855,
		0, 3598, 3598, 3598,
		0, 3341, 3341, 3341,
		0, 3084, 3084, 3084,
		0, 2827, 2827, 2827,
		0, 2570, 2570, 2570,
		0, 2313, 2313, 2313,
		0, 2056, 2056, 2056,
		0, 1799, 1799, 1799,
		0, 1542, 1542, 1542,
		0, 1285, 1285, 1285,
		0, 1028, 1028, 1028,
		0, 771, 771, 771,
		0, 514, 514, 514,
		0, 257, 257, 257,
		0, 0, 0, 0
	}
};

resource 'SIZE' (-1) {
	dontSaveScreen,
	acceptSuspendResumeEvents,
	enableOptionSwitch,
	canBackground,
	multiFinderAware,
	backgroundAndForeground,
	dontGetFrontClicks,
	ignoreChildDiedEvents,
	not32BitCompatible, /* could be 32-bit clean, but not tested yet */
	reserved,
	reserved,
	reserved,
	reserved,
	reserved,
	reserved,
	reserved,
	1572864,
	1572864
};

resource 'vers' (1, purgeable) {
	0x2,
	0x1,
	development,
	0x2,
	verUs,
	"2.1d2",
	"2.1d2,  1989, 1990 ICOM Simulations, Inc.  By Jay Zipnick"
};

resource 'vers' (2, purgeable) {
	0x2,
	0x2,
	development,
	0x2,
	verUs,
	"2.1d2",
	"ICOM CONFIDENTIAL"
};
