/* [INIT31+ Installer.c] START OF FILE */

/* [---BEGIN---] FILE HEADER COMMENTS */

/**
 ** SCREEN VIEW = Palitino-12, Tabs=4
 ** ========================================================================
 ** INIT31+ Installer v1.0
 ** Written by Jim Wolff - (313) 545-1589
 ** [INIT31+ Installer.c] - Installation program for INIT31+
 ** 1989 by Apollyonics Software Development, Inc.
 ** P.O. Box 12134
 ** Birmingham, MI  48012-1234
 ** ========================================================================
 **
 **
 ** ================
 ** Revision History
 ** ================
 **  89.07.16			(Jim Wolff)
 **							Initial coding started 
 **
 **
 **
 ** =================
 ** OTHER INFORMATION
 ** =================
 **
 **
 **
 **/

/* [----END----] FILE HEADER COMMENTS */

#include "INIT31_Installer.h"
#define STACK_SPACE								8192

#define WAIT_NEXT_EVENT_TRAP	0x60
#define UNIMPLEMENTED_TRAP		0x9F


WindowPtr			saved_Owner_Window;
window_Types	last_Window_Type, front_Window_Type;
short						click_Area_Code;
long						vh_Of_Grow_Window;
char						key_Typed;
Point						where_Mouse_Clicked;
Rect						size_Of_Grow_Window;
WindowPtr			temp_Window;
EventRecord		event;
Boolean					there_Is_an_Event_Waiting;

/*************************************************************************/
void Copy_Pascal_String(source_String, destination_String)
char	*source_String, *destination_String;
{
	unsigned char	length_Byte;
	
	length_Byte = (source_String[0] + 1);
	
	BlockMove(source_String, destination_String, length_Byte);
} /* Copy_Pascal_String */
/*************************************************************************/


/*************************************************************************/
Boolean Compare_Pascal_Strings(char *source_String, char *destination_String)
{
	unsigned char	length_Byte;
	int		count;
/* END VAR */

	if (source_String[0] != destination_String[0])
		return(FALSE);
	
	length_Byte = (source_String[0] + 1);

	for ((count = 1); (count < length_Byte); count++)
		if (source_String[count] != destination_String[count])
			return(FALSE);
	
	return(TRUE);
} /* Boolean Compare_Pascal_Strings(char *source_String, char *destination_String) */
/*************************************************************************/


/*************************************************************************/
void Concat_After_Pascal_String(pascal_String, pascal_String_To_Concat)
char	*pascal_String, *pascal_String_To_Concat;
{
	short			new_Length;
	unsigned char	length_To_Copy;
	
	new_Length = (pascal_String[0] + pascal_String_To_Concat[0]);
	if (new_Length > 255)
	{
		length_To_Copy = (255 - pascal_String[0]);
		new_Length = 255;
	} /* if (new_Length > 255) */
	else
		length_To_Copy = pascal_String_To_Concat[0];
		
	BlockMove(&pascal_String_To_Concat[1], &pascal_String[(pascal_String[0] + 1)], length_To_Copy);
	pascal_String[0] = new_Length;
} /* void Concat_After_Pascal_String(pascal_String, pascal_String_To_Concat) */
/*************************************************************************/


/*************************************************************************/
void Concat_Before_Pascal_String(pascal_String_To_Concat, pascal_String)
char	*pascal_String, *pascal_String_To_Concat;
{
	char	scratch_String[256];
	
	Copy_Pascal_String(pascal_String_To_Concat, scratch_String);
	Concat_After_Pascal_String(scratch_String, pascal_String);
	Copy_Pascal_String(scratch_String, pascal_String);
} /* void Concat_After_Pascal_String(pascal_String, pascal_String_To_Concat) */
/*************************************************************************/

/*************************************************************************/
Setup_ASDS_Memory()
{
	long	loop;
/* END VAR */

		SetApplLimit((&loop - STACK_SPACE));

/* SIZE Resource is responsible for telling finder what my minimum memory requirements are, if  */
/* someone so chooses to give me less memory it's not my responsibility if a system error occurs in */
/* the very beginning */

		MaxApplZone();
		for(loop=0; (loop <= MORE_MASTERS_COUNT); loop++)
			MoreMasters();
} /* Setup_ASDS_Memory() */
/*************************************************************************/


/*************************************************************************/
Debug_Initialize()
{
} /* Debug_Initialize() */
/*************************************************************************/


/*************************************************************************/
Create_Stub_Menu_With_Error_Warning()
{
}
/*************************************************************************/


/*************************************************************************/
Boolean Setup_Program_Menus()
{
	short			menu_Index;
	Boolean		missing_Resource;
/* END VAR */

	program_Menus[APPLE_MENU] = GetMenu(APPLE_MENU_ID);
	AddResMenu(program_Menus[APPLE_MENU], 'DRVR');
	program_Menus[FILE_MENU] = GetMenu(FILE_MENU_ID);
	program_Menus[EDIT_MENU] = GetMenu(EDIT_MENU_ID);
	program_Menus[ASDS_MENU] = GetMenu(ASDS_MENU_ID);

	missing_Resource = FALSE;
	menu_Index = 0;
	while((missing_Resource == FALSE) && (menu_Index < MENU_COUNT))
	{
		menu_Index += 1;
		if ((program_Menus[menu_Index] != NIL) && (menu_Index != ASDS_MENU))
			InsertMenu(program_Menus[menu_Index], 0);
		else
			Create_Stub_Menu_With_Error_Warning(menu_Index);
	} /* while((missing_Resource == FALSE) && (menu_Index < MENU_COUNT)) */
	
	if (missing_Resource == TRUE)
		return(FALSE);
	else
		return(TRUE);
} /* Boolean Setup_Program_Menus() */
/*************************************************************************/


/*************************************************************************/
Boolean Initialize_Program()
{
	about_Box_Should_Go_Away = TRUE;
	return(TRUE);
} /* Boolean Initialize_Program() */
/*************************************************************************/


/*************************************************************************/
Initialize_ASDS()
{
	Handle			ResErrProc;
	short				index;
	Str255				string_To_Print;
	long				string_Length;
	Ptr					buffer;
	WDPBRec		working_Directory;
/* END VAR */


	InitGraf(&thePort);
	InitFonts();
	FlushEvents(everyEvent,0);
	InitWindows();
	InitMenus();
	TEInit();
	InitDialogs(0L);

	system_Requested = SYSTEM_604;
	os_Error = SysEnvirons(system_Requested, &system_Environment);

	InitCursor();

	Copy_Pascal_String("\p", &abort_Message);
	
	if (os_Error != noErr)
	{
		abort_Program = TRUE;
		goto Error_Handling_Label;
	} /* if (os_Error != noErr) */

	gray_Region = GetGrayRgn();

	stage_Count_Grow_Zone = 0;
	stage_Count_Restart = 0;


	drag_Rect.left = (screenBits.bounds.left + 4);
	drag_Rect.top = (screenBits.bounds.top + GetMBarHeight() + 4);
	drag_Rect.right = (screenBits.bounds.right - 4);
	drag_Rect.bottom = (screenBits.bounds.bottom - 4);

	
	abort_Function = FALSE;
	abort_Program = FALSE; 
	Copy_Pascal_String("\pNo message set!", &abort_Message);
	
	if (Setup_Program_Menus() == FALSE)
	{
		abort_Program = TRUE;
		Copy_Pascal_String("\pProgram failed to initialize because of menu resources", &abort_Message);
		goto Error_Handling_Label;
	} /* if (Setup_Program_Menus() == FALSE) */

	Debug_Initialize();

	last_Resource_Error = noErr;

	message_Dialog_Active = FALSE;

	application_Resource_Reference = CurResFile();

	UseResFile(0);
	if (ResError() != noErr)
		goto Error_Handling_Label;
	
	system_Resource_Reference = CurResFile();
	os_Error = GetVRefNum(system_Resource_Reference, &system_Volume_Reference);
	if (os_Error != noErr)
		goto Error_Handling_Label;

	UseResFile(application_Resource_Reference);
	if (ResError() != noErr)
		goto Error_Handling_Label;

	if (last_Resource_Error == noErr)
	{
		application_Volume_Reference = 0;
		os_Error = GetVRefNum(application_Resource_Reference, &application_Volume_Reference);
		if (os_Error != noErr)
			abort_Program = TRUE;

		working_Directory.ioNamePtr = NIL;
		os_Error = PBHGetVol(&working_Directory, FALSE);
		if (os_Error != noErr)
			abort_Program = TRUE;

		application_Directory_Reference = working_Directory.ioVRefNum;
		application_Directory_ID = working_Directory.ioWDDirID;

	} /* if (last_Resource_Error == noErr) */

	interactive_Mode = TRUE;
	wait_Next_Event_Is_Implemented = FALSE;
	application_Is_Suspended = FALSE;

	wait_Next_Event_Is_Implemented = 
		(system_Environment.machineType >= 0) &&
			(NGetTrapAddress(WAIT_NEXT_EVENT_TRAP,ToolTrap) !=
		NGetTrapAddress(UNIMPLEMENTED_TRAP,ToolTrap));

		if (Initialize_Program() == FALSE)
			goto Error_Handling_Label;

		InitCursor();

		return;

Error_Handling_Label:
		abort_Program = TRUE;

} /* Initialize_ASDS() */


/*************************************************************************/
/* [---BEGIN---] SUPPORT ROUTINES =========================================== */


/*************************************************************************/
char *Get_Message(message_Number)
long	message_Number;
{
	Copy_Pascal_String("\pMESSAGE NOT FOUND ERROR", (char *)&message_String);
	GetIndString(&message_String, PROGRAM_MESSAGE_STR_LIST_ID, message_Number);
	return ((char *)&message_String);
} /* char *Get_Message(message_Number) */
/*************************************************************************/


/*************************************************************************/
void Center_Window_In_Rect(window_To_Center, rect_To_Center_Within)
WindowPtr			window_To_Center;
register Rect		*rect_To_Center_Within;
{
	Rect	window_Rect;
	short	width, height, left_Global, top_Global;
	
	window_Rect = window_To_Center->portRect;
	width = window_Rect.right - window_Rect.left;
	height = window_Rect.bottom - window_Rect.top;
	left_Global = rect_To_Center_Within->left + ((rect_To_Center_Within->right - 
																	rect_To_Center_Within->left) / 2) - (width / 2);
	top_Global = rect_To_Center_Within->top + ((rect_To_Center_Within->bottom - 
																	rect_To_Center_Within->top) / 2) - (height / 2);
	if (top_Global < (GetMBarHeight() + 5))
		top_Global = (GetMBarHeight() + 5);
	MoveWindow(window_To_Center, left_Global, top_Global, FALSE);
} /* Center_Window_In_Rect */
/*************************************************************************/


/*************************************************************************/
void Center_Window(window_To_Center)
WindowPtr	window_To_Center;
{
	Rect	valid_Screen_Area;
	
	valid_Screen_Area = screenBits.bounds;
	valid_Screen_Area.top = valid_Screen_Area.top + GetMBarHeight();
	Center_Window_In_Rect(window_To_Center, &valid_Screen_Area);
} /* Center_Window */
/*************************************************************************/


/*************************************************************************/
void Center_Window_Upper_One_Third(window_To_Center)
WindowPtr	window_To_Center;
{
	Rect	rect_To_Center_Within;
	
	rect_To_Center_Within = screenBits.bounds;
	rect_To_Center_Within.top = rect_To_Center_Within.top + GetMBarHeight();
	rect_To_Center_Within.bottom = (rect_To_Center_Within.bottom / 2);
	Center_Window_In_Rect(window_To_Center, &rect_To_Center_Within);
} /* Center_Window_Upper_One_Third */
/*************************************************************************/



/*************************************************************************/
void Display_Error_Message(unit_Name, code_Name, description_String, note_String)
char	*unit_Name, *code_Name, *description_String, *note_String;
{
	GrafPtr		saved_Port;
	DialogPtr		error_Dialog;
	Rect			item_Box;
	Handle		item_Handle;
	short			item_Type;
	EventRecord	event;
	
	GetPort(&saved_Port);
	error_Dialog = GetNewDialog(ERROR_DIALOG_ID, NIL, (WindowPtr)-1);
	if (error_Dialog == NIL)
		goto error_Condition_Label;
	
	
	SetPort(error_Dialog);
	Center_Window_Upper_One_Third(error_Dialog);
	
	GetDItem(error_Dialog, MANAGER_ITEM_NO, &item_Type, &item_Handle, &item_Box);
	if (item_Handle == NIL)
		goto error_Condition_Label;
	SetIText(item_Handle, unit_Name);
	
	GetDItem(error_Dialog, CODE_ITEM_NO, &item_Type, &item_Handle, &item_Box);
	if (item_Handle == NIL)
		goto error_Condition_Label;
	SetIText(item_Handle, code_Name);
	
	GetDItem(error_Dialog, DESCRIPTION_ITEM_NO, &item_Type, &item_Handle, &item_Box);
	if (item_Handle == NIL)
		goto error_Condition_Label;
	SetIText(item_Handle, description_String);
	
	GetDItem(error_Dialog, NOTE_ITEM_NO, &item_Type, &item_Handle, &item_Box);
	if (item_Handle == NIL)
		goto error_Condition_Label;
	SetIText(item_Handle, note_String);

	ShowWindow(error_Dialog);
	DrawDialog(error_Dialog);
	InitCursor();

    FlushEvents((mDownMask + keyDownMask),0);
	while (!GetNextEvent((mDownMask + keyDownMask), &event))
		; /* NIL */
			
	DisposDialog(error_Dialog);
	SetPort(saved_Port);
	return;
	
error_Condition_Label:
		SysBeep(10);
		SysBeep(10);
		SysBeep(10);
		SysBeep(10);
		SysBeep(10);
		return;
} /* Display_Error_Message */
/*************************************************************************/


/*************************************************************************/
void Perform_OK_Dialog(message_To_Display)
char	*message_To_Display;
{
	GrafPtr		saved_Port;
	DialogPtr		ok_Dialog;
	Rect			item_Box;
	Handle		item_Handle;
	short			item_Type;
	short			item_Hit;
	EventRecord	event;
	long			final_Ticks;
	
	Copy_Pascal_String(Get_Message(PERFORM_OK_DIALOG_MESSAGE), code_Name);
	
	GetPort(&saved_Port);
	ok_Dialog = GetNewDialog(OK_DIALOG_ID, NIL, (WindowPtr)-1);
	if (ok_Dialog == NIL)
	{
		Display_Error_Message(unit_Name, code_Name,
			Get_Message(GETNEWDIALOG_OK_DIALOG_MESSAGE), Get_Message(NULL_MESSAGE));
		return;
	} /* if (ok_Dialog == NIL) */
	
	SetPort(ok_Dialog);
	Center_Window(ok_Dialog);
	
	GetDItem(ok_Dialog, OK_DIALOG_MESSAGE_ITEM_NO, &item_Type, &item_Handle,
						&item_Box);
	if (item_Handle == NIL)
	{
		Display_Error_Message(unit_Name, code_Name, 
							"\GetDItem OK_DIALOG_MESSAGE_ITEM_NO", Get_Message(NULL_MESSAGE));
		return;
	} /* if (item_Handle == NIL) */
	SetIText(item_Handle, message_To_Display);

	ShowWindow(ok_Dialog);
	DrawDialog(ok_Dialog);
	InitCursor();

	if (interactive_Mode == TRUE)
	{
		item_Hit = 0;
		while (item_Hit != 1)
			ModalDialog(NIL, &item_Hit);
	} /* if (interactive_Mode == TRUE) */
	else
	{
		Delay(180, &final_Ticks);
	} /* NOT if (interactive_Mode == TRUE) */
	
	DisposDialog(ok_Dialog);
	SetPort(saved_Port);
} /* Perform_OK_Dialog */
/*************************************************************************/


/*************************************************************************/
Boolean C_Put_File(prompt, default_Name, sf_Reply)
char	*prompt;
char	*default_Name;
SFReply	*sf_Reply;
{
	Point		dialog_Origin;
	Rect		end_Rect;
	DialogPtr	sf_Put_File_Dialog;
	GrafPtr	saved_Port;


	Copy_Pascal_String(Get_Message(C_PUT_FILE_MESSAGE), code_Name);

	GetPort(&saved_Port);

	sf_Put_File_Dialog = GetNewDialog(putDlgID, NIL, (WindowPtr)-1);
	if (sf_Put_File_Dialog == NIL)
	{
		Display_Error_Message(unit_Name, code_Name,
				Get_Message(GETNEWDIALOG_PUTDLGID_MESSAGE), Get_Message(NULL_MESSAGE));
		return;
	} /* if (sf_Put_File_Dialog == NIL) */

	SetPort(sf_Put_File_Dialog);
	Center_Window(sf_Put_File_Dialog);
	topLeft(end_Rect) = topLeft(sf_Put_File_Dialog->portRect);
	botRight(end_Rect) = botRight(sf_Put_File_Dialog->portRect);
	LocalToGlobal(&topLeft(end_Rect));
	LocalToGlobal(&botRight(end_Rect));
	SetPt(&dialog_Origin, end_Rect.left, end_Rect.top);
	DisposDialog(sf_Put_File_Dialog);
	
	SFPutFile(dialog_Origin, prompt, default_Name, NIL, sf_Reply);
	
	SetPort(saved_Port);
	return sf_Reply->good;
} /* C_Put_File */
/*************************************************************************/


/*************************************************************************/
Boolean C_Get_File(number_Of_Types, type_List, sf_Reply)
short		number_Of_Types;
SFTypeList	*type_List;
SFReply		*sf_Reply;
{
	Point			dialog_Origin;
	Rect			end_Rect;
	DialogPtr		sf_Get_File_Dialog;
	GrafPtr		saved_Port;
	
	Copy_Pascal_String(Get_Message(C_GET_FILE_MESSAGE), code_Name);

	GetPort(&saved_Port);

	sf_Get_File_Dialog = GetNewDialog(getDlgID, NIL, (WindowPtr)-1);
	if (sf_Get_File_Dialog == NIL)
	{
		Display_Error_Message(unit_Name, code_Name,
			Get_Message(GETNEWDIALOG_GETDLGID_MESSAGE), Get_Message(NULL_MESSAGE));
		return;
	} /* if (sf_Get_File_Dialog == NIL) */

	SetPort(sf_Get_File_Dialog);
	Center_Window(sf_Get_File_Dialog);
	topLeft(end_Rect) = topLeft(sf_Get_File_Dialog->portRect);
	botRight(end_Rect) = botRight(sf_Get_File_Dialog->portRect);
	LocalToGlobal(&topLeft(end_Rect));
	LocalToGlobal(&botRight(end_Rect));
	SetPt(&dialog_Origin, end_Rect.left, end_Rect.top);
	DisposDialog(sf_Get_File_Dialog);
	
	SFGetFile(dialog_Origin, NIL, NIL, number_Of_Types, type_List, NIL, sf_Reply);
	
	SetPort(saved_Port);
	return sf_Reply->good;
} /* C_Get_File */
/*************************************************************************/


/*************************************************************************/

/*************************************************************************/
Boolean Perform_Event_Loop_And_Check_User_Abort()
{
	Boolean			there_Is_An_Event_Waiting;
	EventRecord		event_Record;
	GrafPtr			saved_Port;
	WindowPtr		event_Window;
	Point			click_Point;
	short			part_Code;
	ControlHandle	active_Control;
	
	
	if (wait_Next_Event_Is_Implemented)
		there_Is_An_Event_Waiting = WaitNextEvent(everyEvent, &event_Record, 1, NIL);
	else
	{
		SystemTask();
		there_Is_An_Event_Waiting = GetNextEvent(everyEvent, &event_Record);
	}
	
	if (there_Is_An_Event_Waiting)
	{
		switch(event_Record.what)
		{
			case app4Evt:
				if (event_Record.message & 1)
					application_Is_Suspended = FALSE;
				else
					application_Is_Suspended = TRUE;
				break;
			
			case keyDown:
			case autoKey:
				if (((char)event_Record.message == '.') && (event_Record.modifiers & cmdKey))
					return TRUE;
				break;
			
			case updateEvt:
				event_Window = (WindowPtr)event_Record.message;
				GetPort(&saved_Port);
				SetPort(event_Window);
				BeginUpdate(event_Window);
				/* Update_Status_Window(); */
				EndUpdate(event_Window);
				SetPort(saved_Port);
				break;
			
			case activateEvt:
				event_Window = (WindowPtr)event_Record.message;
				if (event_Window == event_Window)
				{
					if (event_Record.modifiers & activeFlag)
						application_Is_Suspended = FALSE;
					else
						application_Is_Suspended = TRUE;
				} /* if (event_Window == event_Window) */
				break;
			
			case mouseDown:
				switch (FindWindow(event_Record.where, &event_Window))
				{
					case inDrag:
						DragWindow(event_Window, event_Record.where, &drag_Rect);
						break;
					
					case inContent:
						if (event_Window == event_Window)
						{
							GetPort(&saved_Port);
							SetPort(event_Window);
							click_Point = event_Record.where;
							GlobalToLocal(&click_Point);
							if (FindControl(click_Point, event_Window, &active_Control))
								if (active_Control == active_Control)
								{
									if (part_Code = TrackControl(active_Control, click_Point, NIL))
										return TRUE;
								} /* if (active_Control == active_Control) */
							SetPort(saved_Port);
						} /* if (event_Window == event_Window) */
						break;
				} /* switch (FindWindow(event_Record.where, &event_Window)) */
			
			default:
				break;
		} /* switch(event.what) */
	} /* if (there_Is_An_Event_Waiting) */
	
	return FALSE;
} /* Boolean Perform_Event_Loop_And_Check_User_Abort() */
/*************************************************************************/


/*************************************************************************/
pascal void Fill_Byte_Buffer(buffer, buffer_Size, value)
char	*buffer;
long	buffer_Size;
short	value;
{
	asm
	{
		MOVEM.L	D0-D3/A0-A4,-(SP)			; WE USE THEM ALL SO SAVE 'EM ...

		MOVE.L		buffer(A6),A0					; A0 = startAddress
		MOVE.L		buffer_Size(A6),D0			; D0 = amount
		CLR.L				D1
		MOVE.W		value(A6),D1					; D1.B = zapValue

; Copy the byte at D1.B into all 4 bytes of D1.L

		CLR.L				D2
		MOVE.B 		 D1,D2
		LSL.W			#8,D1
		OR.W				D2,D1
		MOVE.W 		 D1,D2
		SWAP			D1
		OR.L				D2,D1									; D1.L = [zapValue,zapValue,zapValue,zapValue]


		JSR					@FBB0								; FILL THAT BUFFER!

		MOVEM.L	(SP)+,D0-D3/A0-A4		; RESTORE REGS
		UNLK			A6										; BYE, BYE STACK FRAME ...
		MOVEA.L		(SP)+,A0							; WHERE DID WE COME FROM?
		LEA				10(SP),SP							; DON'T BE WASTING MY STACK SPACE!
																			; 10 is size of passed parameters...

		JMP					(A0)									; GOING HOME ...

FBB0:

; MOD 2 buffer pointer to determine offset until buffer is word aligned
; Fill the buffer until word aligned
; DIV amount left by size of big-loop chuncks (64) to determine number of big-loops
; MOD amount left by size of big-loop chuncks (64) to determine end bytes
; Fill the buffer using big loops
; Fill the rest of the buffer using the end loop

		MOVE.L		A0,D2									; D2.L = Address of buffer to be filled
		ANDI.L			#1,D2									; MOD 2 to get offset until word boundry

		BEQ				@FBB2								; SKIP AROUND IF NONE TO DO

; Word align buffer

		SUBQ.L			#1,D0									; ADJUST AMOUNT COUNTER (D0 = D0 - 1)
		MOVE.B		D1,(A0)+							; A0 is now word aligned

FBB2:	
		MOVE.L		D0,D2									; TWO COPIES, TWO REASONS
		MOVE.L		D2,D3									; D0, D2, D3 = amount left to fill (bytes)

		AND.L			#0x3F,D3							; AMOUNT = AMOUNT MOD 64 ( END PART )
		LSR.L				#6,D2									; AMOUNT = AMOUNT DIV 64 ( MAIN LOOP )
		BEQ				@FBB4								; BRANCH AROUND IF NO FULL LOOPS

; Fill in buffer with blocks for long words

		SUBQ				#1,D2								; DBRA ADJUSTED ...
FBB3:	
		MOVE.L		D1,(A0)+						; DO ALL THE FULL LOOPS
		MOVE.L		D1,(A0)+
		MOVE.L		D1,(A0)+
		MOVE.L		D1,(A0)+
		MOVE.L		D1,(A0)+
		MOVE.L		D1,(A0)+
		MOVE.L		D1,(A0)+
		MOVE.L		D1,(A0)+
		MOVE.L		D1,(A0)+
		MOVE.L		D1,(A0)+
		MOVE.L		D1,(A0)+
		MOVE.L		D1,(A0)+
		MOVE.L		D1,(A0)+
		MOVE.L		D1,(A0)+
		MOVE.L		D1,(A0)+
		MOVE.L		D1,(A0)+
		DBRA			D2,@FBB3

FBB4:
		MOVE.L		D3,D2								; TO SET ZERO FLAGS ETC...
		BEQ				@FBB6							; BRANCH AROUND IF NONE TO DO

; Fill in the rest of the buffer (using bytes at a time)

		SUBQ				#1,D2								; DBRA ADJUSTED ...
FBB5:	
		MOVE.B		D1,(A0)+						; Fill the buffer
		DBRA			D2,@FBB5

FBB6:	
		RTS														; THAT'S ALL FOLKS

	}
} /* Fill_Byte_Buffer */
/*************************************************************************/
/* [----END----] SUPPORT ROUTINES =========================================== */



/*************************************************************************/
#define CODE_NAME = "\pPerform_Disk_Event"
#define DISK_INITIALIZATION_DIALOG_ID	-6047

void Perform_Disk_Event()
{
	DialogPtr		disk_Initialization_Dialog;
	GrafPtr			saved_Port;
	Point				top_Left;
/* END VAR */

	if (HiWord(event.message) != noErr)
	{
		GetPort(&saved_Port);
		disk_Initialization_Dialog = GetNewDialog(DISK_INITIALIZATION_DIALOG_ID, NIL, NIL);
		SetPort(disk_Initialization_Dialog);
		HideWindow(disk_Initialization_Dialog);
		Center_Window_Upper_One_Third(disk_Initialization_Dialog);
		top_Left = topLeft(disk_Initialization_Dialog->portRect);
		LocalToGlobal(&top_Left);
		DisposDialog(disk_Initialization_Dialog);

		os_Error = DIBadMount(top_Left, event.message);

		SetPort(saved_Port);
		
	} /* if (HiWord(event.message) != noErr) */
} /* Perform_Disk_Event() */
/*************************************************************************/


/*************************************************************************/
void Perform_ASDS_Key(WindowPtr window_Typed_In, char key_Typed)
{
} /* void Perform_ASDS_Key() */
/*************************************************************************/


/*************************************************************************/
#define MAXIMUM_NUMBER_OF_STEPS			15
#define NUMBER_OF_TRAIL_RECTS						5
#define DELAY_TICKS													1

Rect			rects_To_Frame[(MAXIMUM_NUMBER_OF_STEPS+1)];
short			geometric_Steps, count;
Fixed			spacing_Factor, spacing_Left, spacing_Right, spacing_Top, spacing_Bottom;
Fixed			fixed_Left, fixed_Right, fixed_Top, fixed_Bottom;
GrafPtr		save_Port;
GrafPort		desk_Port;
long			final_Ticks;

void Internal_Zoom_Rect(Rect begin_Rect, Rect end_Rect, short number_Of_Steps)
{
	short		count;
/* END VAR */

	GetPort(&save_Port);
	OpenPort(&desk_Port);
	SetPort(&desk_Port);

	geometric_Steps = (number_Of_Steps - 1) * number_Of_Steps;

	fixed_Left = FixRatio(begin_Rect.left, 1);
	fixed_Top = FixRatio(begin_Rect.top, 1);
	fixed_Right = FixRatio(begin_Rect.right, 1);
	fixed_Bottom = FixRatio(begin_Rect.bottom, 1);

	spacing_Left = FixRatio((end_Rect.left - begin_Rect.left), geometric_Steps);
	spacing_Top = FixRatio((end_Rect.top - begin_Rect.top), geometric_Steps);
	spacing_Right = FixRatio((end_Rect.right - begin_Rect.right), geometric_Steps);
	spacing_Bottom = FixRatio((end_Rect.bottom - begin_Rect.bottom), geometric_Steps);

	for (count=1; (count <= number_Of_Steps); count++)
	{
		spacing_Factor = FixRatio(count * (count + 1), 1);
		rects_To_Frame[count].left = FixRound(fixed_Left + FixMul(spacing_Factor, spacing_Left));
		rects_To_Frame[count].right = FixRound(fixed_Right + FixMul(spacing_Factor, spacing_Right));
		rects_To_Frame[count].top = FixRound(fixed_Top + FixMul(spacing_Factor, spacing_Top));
		rects_To_Frame[count].bottom = FixRound(fixed_Bottom + FixMul(spacing_Factor, spacing_Bottom));
	} /*for (count=1; (count <= number_Of_Steps); count++)  */

	PenPat(gray);
	PenMode(notPatXor);

	FrameRect(&begin_Rect);
	Delay(DELAY_TICKS, &final_Ticks);

	for (count=1; (count <= NUMBER_OF_TRAIL_RECTS); count++)
	{
		FrameRect(&rects_To_Frame[count]);
		Delay(DELAY_TICKS, &final_Ticks);
	} /* for (count=1; (count <= NUMBER_OF_TRAIL_RECTS); count++) */

	FrameRect(&begin_Rect);
	Delay(DELAY_TICKS, &final_Ticks);

	for ((count=(NUMBER_OF_TRAIL_RECTS+1)); (count <= (number_Of_Steps-2)); count++)
	{
		FrameRect(&rects_To_Frame[count]);
		FrameRect(&rects_To_Frame[(count - NUMBER_OF_TRAIL_RECTS)]);
		Delay(DELAY_TICKS, &final_Ticks);
	} /* for ((count=(NUMBER_OF_TRAIL_RECTS+1)); (count <= (number_Of_Steps-2)); count++) */

	FrameRect(&end_Rect);
	Delay(DELAY_TICKS, &final_Ticks);

	for ((count=((number_Of_Steps - 2 - NUMBER_OF_TRAIL_RECTS) + 1));
			(count <= (number_Of_Steps - 2)); count++)
	{
		FrameRect(&rects_To_Frame[count]);
		Delay(DELAY_TICKS, &final_Ticks);
	} /* for ((count=((number_Of_Steps - 2 - NUMBER_OF_TRAIL_RECTS) + 1)); */
					/* (count <= (number_Of_Steps - 2)); count++) */
	
	FrameRect(&end_Rect);

	ClosePort(&desk_Port);
	SetPort(save_Port);

} /* void Internal_Zoom_Rect(Rect begin_Rect, Rect end_Rect, short number_Of_Steps) */
/*************************************************************************/


/*************************************************************************/
void Zoom_Rect(Rect begin_Rect, Rect end_Rect)
{
	InsetRect(&end_Rect, (MAXIMUM_NUMBER_OF_STEPS * 2), (MAXIMUM_NUMBER_OF_STEPS * 2));
	Internal_Zoom_Rect(begin_Rect, end_Rect, MAXIMUM_NUMBER_OF_STEPS);
	begin_Rect = end_Rect;
	InsetRect(&end_Rect, (-MAXIMUM_NUMBER_OF_STEPS * 2), (-MAXIMUM_NUMBER_OF_STEPS * 2));
	Internal_Zoom_Rect(begin_Rect, end_Rect, (MAXIMUM_NUMBER_OF_STEPS / 2));
} /* void Zoom_Rect(Rect begin_Rect, Rect end_Rect) */
/*************************************************************************/


/*************************************************************************/
/* Used in string routines when no additional padding (beyond 1 char) desired */
#define NO_PAD			1

/* passed to the number to string routines to Strip_Outside_Controls before return */
#define NO_LIMIT			0

/* 12 spaces */
#define MINI_BLANK_STRING						"\p            "

#define MINI_BLANK_STRING_LENGTH		12
#define ASCII_SPACE											0x20

void Convert_Longint_To_String(long longint_Value, short size, Str255 *string_Value)
{
	Str255		hold_String, result;
	short		size_Of_String;
/* END VAR */

		NumToString(longint_Value, hold_String);
		
		if (size == 0)
			Copy_Pascal_String(&hold_String, string_Value);
		else
		{
			size_Of_String = hold_String[0];
			
			if (size_Of_String < size)
			{
				if (size <= (MINI_BLANK_STRING_LENGTH + size_Of_String))
				{
					Copy_Pascal_String(MINI_BLANK_STRING, &result);
					result[0] = (size - size_Of_String);
					
					Copy_Pascal_String(&result, string_Value);
				} /* if (size <= (MINI_BLANK_STRING_LENGTH + size_Of_String)) */
				else
				{
					Fill_Byte_Buffer(&result, ((size - size_Of_String + 1)), ASCII_SPACE);
					
					result[0] = (size - size_Of_String);
					
					Copy_Pascal_String(&result, &hold_String);
				} /* NOT if (size <= (MINI_BLANK_STRING_LENGTH + size_Of_String)) */
			} /* if (size_Of_String < size) */
			else
			{
				if ((size >= 0) && (size <= 255))
					hold_String[0] = size;
				else
					hold_String[0] = 0;
				
				Copy_Pascal_String(&hold_String, string_Value);
			} /* NOT if (size_Of_String < size) */
		} /* NOT if (size == 0) */


} /* void Convert_Longint_To_String(long longint_Value, short size, Str255 *string_Value) */
/*************************************************************************/


/*************************************************************************/
void Install_INIT31_Into_System(short resource_ID)
{
	Handle			init_31_Resource;
	short 				resource_Attributes;

/* END VAR */

	/* UseResFile(SysMap); */
	UseResFile(system_Resource_Reference);
	if (ResError() != noErr)
		goto Error_Handler_Label;
	
	init_31_Resource = GetResource('INIT', 31);

	while (init_31_Resource != NIL)
	{
		RmveResource(init_31_Resource);
		if (ResError() != noErr)
			goto Error_Handler_Label;
		
		DisposHandle(init_31_Resource);
		if (MemError() != noErr)
			goto Error_Handler_Label;
		
		init_31_Resource = GetResource('INIT', 31);
		
	} /* while (init_31_Resource != NIL) */

	UseResFile(application_Resource_Reference);
	if (ResError() != noErr)
		goto Error_Handler_Label;

	init_31_Resource = GetResource('INIT', resource_ID);
	if (init_31_Resource == NIL)
		goto Error_Handler_Label;

	DetachResource(init_31_Resource);
	if (ResError() != noErr)
		goto Error_Handler_Label;

	/* UseResFile(SysMap); */
	UseResFile(system_Resource_Reference);
	if (ResError() != noErr)
		goto Error_Handler_Label;

	AddResource(init_31_Resource, 'INIT', 31, "\p");
	if (ResError() != noErr)
		goto Error_Handler_Label;

	resource_Attributes = GetResAttrs(init_31_Resource);
	if (ResError() != noErr)
		goto Error_Handler_Label;
	
	SetResAttrs(init_31_Resource, (resource_Attributes | resSysHeap | resLocked));
	if (ResError() != noErr)
		goto Error_Handler_Label;

	UpdateResFile(system_Resource_Reference);
	if (ResError() != noErr)
		goto Error_Handler_Label;
	
	ReleaseResource(init_31_Resource);
	if (ResError() != noErr)
		goto Error_Handler_Label;

	UseResFile(application_Resource_Reference);
	if (ResError() != noErr)
		goto Error_Handler_Label;

	return;
	
Error_Handler_Label:
	Display_Error_Message("\pINIT31_Installer","\pInstall_INIT31()","\p","\p");
} /* void Install_INIT31_Into_System(short resource_ID) */
/*************************************************************************/


/*************************************************************************/
void Install_INIT31()
{
	Install_INIT31_Into_System(1);
} /* void Install_INIT31() */
/*************************************************************************/


/*************************************************************************/
void Remove_INIT31()
{
	Install_INIT31_Into_System(0);
} /* void Remove_INIT31() */
/*************************************************************************/


/*************************************************************************/
#include <color.h>

long Get_Bit_Depth_Of_Main_Device()
{
	GDHandle		main_Device;
	short				bits_Per_Pixel;
/* END VAR */

	bits_Per_Pixel = 1;
	if (system_Environment.hasColorQD == TRUE)
	{
		main_Device = NIL;
		main_Device = GetMainDevice();
		bits_Per_Pixel = (**(**main_Device).gdPMap).pixelSize;
	} /* if (system_Environment.hasColorQD == TRUE) */
	
	return(bits_Per_Pixel);
} /* long Get_Bit_Depth_Of_Main_Device() */
/*************************************************************************/


/*************************************************************************/
void Update_ASDS_Windows()
{
} /* void Update_ASDS_Windows() */
/*************************************************************************/


/*************************************************************************/
DialogPtr			about_Dialog;
short					font_Height, string_Width;
Str255					info_String;
FontInfo			font_Info;

void Update_About_Box()
{
	GrafPtr			saved_Port;
	short				horizontal_Position, vertical_Position;
	Rect				scratch_Rect;
/* END VAR */

	GetPort(&saved_Port);
	SetPort(about_Dialog);
	
	BeginUpdate(about_Dialog);

	TextFont(applFont);
	TextSize(12);
	TextFace(0);

	DrawDialog(about_Dialog);

	TextFont(geneva);
	TextSize(9);
	TextFace(bold);

	scratch_Rect = about_Dialog->portRect;
	horizontal_Position = (((scratch_Rect.right - scratch_Rect.left) / 2) - (string_Width / 2));
	vertical_Position = (scratch_Rect.bottom - font_Height + font_Info.ascent - 1);
	MoveTo(horizontal_Position, vertical_Position);
	DrawString(info_String);
	
	EndUpdate(about_Dialog);

	SetPort(saved_Port);
} /* void Update_About_Box() */
/*************************************************************************/


/*************************************************************************/
#define ABOUT_ID_COLOR		128
#define ABOUT_ID_BW				131
#define TICKS_BEFORE_ABOUT_BOX_CLOSES		360
#define SHORT_TICKS_BEFORE_ABOUT_BOX_CLOSES		60

void Perform_ASDS_About_Box()
{
	long					ending_Time;
	GrafPtr				old_Port;
	EventRecord	wait_Event;
	Rect					begin_Rect, end_Rect;
	short					about_ID;
	Boolean				done;
	short					message, count;
/* END VAR */

	GetPort(&old_Port);

	if (Get_Bit_Depth_Of_Main_Device() > 2)
		about_ID = ABOUT_ID_COLOR;
	else
		about_ID = ABOUT_ID_BW;

	about_Dialog = GetNewDialog(about_ID, NIL, (WindowPtr)-1);

	SetPort(about_Dialog);
	Center_Window(about_Dialog);
	
	end_Rect = about_Dialog->portRect;
	
	LocalToGlobal(&topLeft(end_Rect));
	LocalToGlobal(&botRight(end_Rect));
	
	begin_Rect.left = screenBits.bounds.left;
	begin_Rect.top = GetMBarHeight();
	begin_Rect.right = (begin_Rect.left + 20);
	begin_Rect.bottom = (begin_Rect.top + 5);
	
	Zoom_Rect(begin_Rect, end_Rect);

	ShowWindow(about_Dialog);

	SetPort(about_Dialog);

	TextFont(geneva);
	TextSize(9);
	TextFace(bold);
	
	GetFontInfo(&font_Info);
	
	font_Height = (font_Info.ascent + font_Info.descent + font_Info.leading);

	Convert_Longint_To_String(FreeMem(), NO_LIMIT, &info_String);
	Concat_Before_Pascal_String("\pFree Memory = ", &info_String);
	string_Width = StringWidth(&info_String);

	if(about_Box_Should_Go_Away == TRUE)
	{
		CountAppFiles(&message, &count);

		if(count ==0)
			ending_Time = (TickCount() + TICKS_BEFORE_ABOUT_BOX_CLOSES);
		else
			ending_Time = (TickCount() + SHORT_TICKS_BEFORE_ABOUT_BOX_CLOSES);
	} /* if(about_Box_Should_Go_Away == TRUE) */

	done = FALSE;
	
	do /* while(done == FALSE); */
	{
		if (EventAvail(updateMask, &wait_Event) == TRUE)
		{
			if (about_Dialog == (WindowPtr)wait_Event.message)
				Update_About_Box();
			else
				Update_ASDS_Windows();
		} /* if (EventAvail(updateMask, &wait_Event) == TRUE) */
		
		if (about_Box_Should_Go_Away == TRUE)
			if (TickCount() > ending_Time)
				done = TRUE;
		
		if (done == FALSE)
			done = EventAvail((mDownMask + keyDownMask + autoKeyMask), &wait_Event);
	} while(done == FALSE);

	about_Box_Should_Go_Away = FALSE;

	DisposDialog(about_Dialog);
	SetPort(old_Port);
} /* void Perform_ASDS_About_Box() */
/*************************************************************************/


/*************************************************************************/
void Perform_Startup_Action()
{
	DrawMenuBar();
	Perform_ASDS_About_Box();
} /* void Perform_Startup_Action */
/*************************************************************************/


/*************************************************************************/
void Execute_ASDS_Command(long menu_Result, Boolean keyboard_Selected)
{
	short					item_Selected, menu_Selected, temp, loop;
	Str255					desk_Accessory_Name;
	long					scrap_Error;
	short					scrap_Copy_Error;
	GrafPtr				saved_Port;
	WindowPtr		front_Window;
/* END VAR */

		item_Selected = LoWord(menu_Result);
		menu_Selected = HiWord(menu_Result);

		switch (menu_Selected)
		{
			case APPLE_MENU_ID:
				if(item_Selected = ABOUT_ITEM)
					Perform_ASDS_About_Box();
				else
				{
					GetItem(program_Menus[APPLE_MENU], item_Selected, &desk_Accessory_Name);
					scrap_Error = ZeroScrap();
					scrap_Copy_Error = TEToScrap();
					GetPort(saved_Port);
					temp = OpenDeskAcc(desk_Accessory_Name);
					SetPort(saved_Port);
					EnableItem(program_Menus[EDIT_MENU], 0);
					if (FrontWindow() != NIL)
					{
						EnableItem(program_Menus[EDIT_MENU], CLOSE_ITEM);
						EnableItem(program_Menus[EDIT_MENU], UNDO_ITEM);
					} /* if (FrontWindow() != NIL) */
				} /* NOT if(item_Selected = ABOUT_ITEM) */
				break;
			
			case FILE_MENU_ID:
				switch (item_Selected)
				{
					case INSTALL_INIT31:
						Install_INIT31();
						break;
					
					case REMOVE_INIT31:
						Remove_INIT31();
						break;
					
					case QUIT_ITEM:
					case ALTERNATE_QUIT_ITEM:
						done_Event_Loop = TRUE;
						break;
					
					default:
						break;
				} /* switch (item_Selected) */
				break;
			
			default:
				if (keyboard_Selected == TRUE)
					SysBeep(10);
		} /* switch (menu_Selected) */

		HiliteMenu(0);
} /* void Execute_ASDS_Command() */
/*************************************************************************/


/*************************************************************************/
void Perform_Mouse_Down()
{
	WindowPtr		window_Clicked_In;
	Point					where_Mouse_Clicked;
/* END VAR */

	where_Mouse_Clicked = event.where;
	click_Area_Code = FindWindow(where_Mouse_Clicked, &window_Clicked_In);
	switch(click_Area_Code)
	{
		case inMenuBar:
			Execute_ASDS_Command(MenuSelect(where_Mouse_Clicked), FALSE);
			break;
			
		case inSysWindow:
			SystemClick(&event, window_Clicked_In);
			break;
		
		case inDrag:
			DragWindow(window_Clicked_In, where_Mouse_Clicked, &drag_Rect);
			break;
		
		case inGoAway:
			break;
		
		case inZoomIn:
		case inZoomOut:
			break;
		
		case inGrow:
			break;
		
		case inContent:
			break;
		
		default:
			break;
			
	} /* switch(click_Area_Code) */
} /* void Perform_Mouse_Down() */
/*************************************************************************/


/*************************************************************************/
void Perform_Periodic_Events()
{
} /* Perform_Periodic_Events() */
/*************************************************************************/


/*************************************************************************/
void Update_ASDS_Window()
{
} /* void Update_ASDS_Window() */
/*************************************************************************/


/*************************************************************************/
void Activate_ASDS_Window()
{
} /* void Activate_ASDS_Window() */
/*************************************************************************/


/*************************************************************************/
long Get_Window_Type(WindowPtr window_To_Examine)
{
} /* long Get_Window_Type(WindowPtr window_To_Examine) */
/*************************************************************************/


/*************************************************************************/
Perform_ASDS_Event_Loop()
{
	last_Window_Type = system_Type;
	while (done_Event_Loop == FALSE)
	{
		front_Window_Type = (window_Types)Get_Window_Type(FrontWindow());
		if (last_Window_Type != front_Window_Type)
		{
			switch(front_Window_Type)
			{
				case no_Window:
					DisableItem(program_Menus[FILE_MENU], CLOSE_ITEM);
					DisableItem(program_Menus[EDIT_MENU], 0);
					DrawMenuBar();
					last_Window_Type = front_Window_Type;
					
				case system_Type:
					EnableItem(program_Menus[FILE_MENU], CLOSE_ITEM);
					EnableItem(program_Menus[EDIT_MENU], 0);
					DrawMenuBar();
					last_Window_Type = front_Window_Type;
					
				default:
					break;
			} /* switch(front_Window_Type) */
		} /* if (last_Window_Type != front_Window_Type) */
		

		abort_Function = FALSE;
	
		if (wait_Next_Event_Is_Implemented == TRUE)
			there_Is_an_Event_Waiting = WaitNextEvent(everyEvent, &event, 1, NIL);
		else
		{
			SystemTask();
			there_Is_an_Event_Waiting = GetNextEvent(everyEvent, &event);
		} /* NOT if (wait_Next_Event_Is_Implemented == TRUE) */
	
		if (there_Is_an_Event_Waiting == TRUE)
		{
			switch (event.what)
			{
				case app4Evt:
					if ((event.message & 0x00000001) != 0)
						application_Is_Suspended = TRUE;
					else
						application_Is_Suspended = FALSE;
					break;
			
				case mouseDown:
					Perform_Mouse_Down();
					break;
			
				case keyDown:
				case autoKey:
					key_Typed = (event.message & charCodeMask);
					if (event.modifiers & cmdKey)
						Execute_ASDS_Command(MenuKey(key_Typed), TRUE);
					else
						Perform_ASDS_Key(FrontWindow(), key_Typed);
					break;
			
				case activateEvt:
					Activate_ASDS_Window((WindowPtr)event.message,(event.modifiers & activeFlag));
					break;
			
				case updateEvt:
					Update_ASDS_Window((WindowPtr)event.message);
					break;
			
				case diskEvt:
					Perform_Disk_Event;
					break;
			
				default:
					break;
			} /* swtch (event.what) */
		} /* if (there_Is_an_Event_Waiting == TRUE) */
		else
			Perform_Periodic_Events();
		
	} /* while (done_Event_Loop == FALSE) */



} /* Perform_ASDS_Event_Loop */
/*************************************************************************/


/*************************************************************************/
Perform_ASDS_Abort_Launch()
{
} /* Perform_ASDS_Abort_Launch */
/*************************************************************************/


/*************************************************************************/
Perform_ASDS_Quit()
{
} /* Perform_ASDS_Quit */
/*************************************************************************/

/*************************************************************************/
void main()
{
/* END VAR */
	Setup_ASDS_Memory();
	Initialize_ASDS();
	
	if(abort_Program == FALSE)
	{
		if(done_Event_Loop == FALSE)
		{
			Perform_Startup_Action();
			Perform_ASDS_Event_Loop();
		} /* if(done_Event_Loop == FALSE) */
		else
			Perform_ASDS_Abort_Launch();
	} /* if(abort_Program == FALSE) */
	else
		Perform_ASDS_Abort_Launch;

	Perform_ASDS_Quit();

} /* void main() */
/*************************************************************************/

/* [INIT31+ Installer.c] END OF FILE */
