/************************************************************************************/
/* 								Error Declarations for the MIDI Drivers						*/
/************************************************************************************/
/* Version: 1.0			Written by Chris Marshall September 22nd, 1989					*/
/* 										1989 by Chris Marshall										*/
/* Written using the THINK C version 4.0 development system.								*/
/************************************************************************************/
/* These are universal error definitions used by all of the MIDI drivers.				*/
/************************************************************************************/

#define	OPENBAD		openErr		/* Failed to properly initialize the driver			*/
#define	PRIMEBAD		1004			/* Error during a prime call 								*/
#define	READBAD		readErr		/* Error during a read call								*/
#define	WRITEBAD		writErr		/* Error during a write call								*/
#define	CONTROLBAD	controlErr	/* Error during a control call							*/
#define	STATUSBAD	statusErr	/* Error during a status call								*/
#define	CLOSEBAD		closErr		/* Error during driver close								*/

/************************************************************************************/
/* Error return defines	for the low-level drivers												*/
/************************************************************************************/

#define	STASHERR		1000		/* Improper stash location (should never happen)		*/
#define	NOSTASH		1001		/* There has been an attempt to use stash when empty	*/
#define	INBUFFOV		1002		/* Primary buffer overflow for input buffer				*/
#define	OUTBUFFOV	1003		/* Primary buffer overflow for output buffer				*/

/************************************************************************************/
