/*
	Copyright  1988,1989,1990 by Succinct Systems

	433 Huronview
	Ann Arbor, MI 48103
	(313) 663-4903

	File: 		GeeWhiz.Demo.c
	Model: 		THINK C 4.0, MPW C 3.0

	ABSTRACT:
		This is a "standard" demo source code template. This file contains a
		number of routines to enable a reasonably complete demo application
		to be whipped up in short order.

	NOTES:
		The following routines are implemented herein:
			main, DoPeriodicTasks, GetEvent, DoEvent, DoMenuCommand,
			DoMouseEvent, DoActivate, DoUpdate, StdMacInit, TrapAvailable,
			InstallStandardMenus, CheckError

	KNOWN BUGS:
		---

	HISTORY:
		DAS 13-Apr-90	copied this from (16-Nov-89) template	(David A. Surovell)
*/

#include <StdMacIncludes.h>				/* include standard Mac headers */
#include <Compatibility.h>				/* define compatibility control structures */
#include <Offscreen.Think.h>			/* include current QD-32, Sys7.0 defs */
#include "PixMapFileIO.h"
#include "GeeWhiz.Demo.h"

PixMapHandle GWorld_GetPixMap(
	GWorldPtr	theGWorld );



SysEnvRec		gSysEnvirornInfo;			/* Mac OSs world, via SysEnvirons	*/
GWorldPtr		gWorldInfo;					/* current color world */
EventRecord		gMainEvent;					/* Main Event Loop information */
MenuHandle		gMenuHdlApple;				/* handles for standard Mac menus */
MenuHandle		gMenuHdlFile;
MenuHandle		gMenuHdlEdit;
MenuHandle		gMenuHdl_GWorlds;			/* additional demo menu handles */
WindowPtr		gDemoWP;					/* window-related data structures */
WindowRecord	gDemoWR;
Rect			gDragRect;
Rect			gGrowRect;
Point			gLocalPt;

Boolean			gRunningMF;					/* TRUE if MultiFinder running */
Boolean			gHasEvent;					/* TRUE if appl received an event */
short			gMFYield;					/* yieldtime under MultiFinder */
Boolean			gInForeground = TRUE;		/* are we MultiFinders foreground appl? */
Boolean			gRunningQD32;				/* QuickDraw-32 presence flag */

Boolean			gUserDone = FALSE;

short			gCurGWPixDepth;
GWorldFlags		gwOptionFlags = 0L;			/* current gw options: stretch | dither */


pascal OSErr main( void )
{
GDHandle		curGDevHdl;
CTabHandle		curCTabHdl;
PixMapHandle	curPMHdl;
Rect			boundsRect;
QDErr			qdErrStat;

	/* initialize Toolbox mgrs, set up standard menus */
	StdMacInit( 20 );
	InstallStandardMenus( &gMenuHdlApple, &gMenuHdlFile, &gMenuHdlEdit );

	/* get the demo command menu */
	gMenuHdl_GWorlds = GetMenu( kMENU_gworld_control );
	if (gMenuHdl_GWorlds != NULL)
		InsertMenu( gMenuHdl_GWorlds, 0 );
	DrawMenuBar();

	gDemoWP = (WindowPtr)GetNewCWindow( kWIND_demo, &gDemoWR, (WindowPtr)(-1) );
	if (gDemoWP != NULL)
	{
		SetPort( gDemoWP );
		TextFont( systemFont );

		ShowWindow( gDemoWP );
		SelectWindow( gDemoWP );
	}
	else
		SysBeep( 1 );

	curGDevHdl = NULL;
	curCTabHdl = NULL;

#ifdef _ONLY_WHEN_PIX_DEPTH_IS_ZERO_
	SetRect( &boundsRect, 0, 0, 640, 480 );
	qdErrStat = NewScreenBuffer( &boundsRect, FALSE, &curGDevHdl, &curPMHdl );
	if (CheckError( qdErrStat ))
		;
#endif _ONLY_WHEN_PIX_DEPTH_IS_ZERO_

	gCurGWPixDepth = 8;
	SetRect( &boundsRect, 0, 0, 640, 480 );
	qdErrStat = NewGWorld(
		&gWorldInfo, gCurGWPixDepth, &boundsRect, curCTabHdl,
		curGDevHdl, gwNoFlags );
	if (CheckError( qdErrStat ))
		ExitToShell();

	do
	{
		DoPeriodicTasks( gInForeground );

		/* repeat until program terminates */
		gHasEvent = GetEvent( everyEvent, &gMainEvent, gRunningMF, gMFYield );

		/* handle all standard events and menu-based commands */
		DoEvent( &gMainEvent );

		/* perform any additional stuff */
		gLocalPt = gMainEvent.where;
		GlobalToLocal( &gLocalPt );
		if ((gMainEvent.what == mouseDown) && (gDemoWP == FrontWindow()))
		{
		}
	} while (!gUserDone);
}


void DoPeriodicTasks(
	Boolean		inBackground )
{
	/* perform any program-specific, ongoing work */
	/* particularly cursor adjustment */
}


Boolean GetEvent(
	short			theEventMask,
	EventRecord		*theEvent,
	Boolean			mfAvail,
	short			theYieldTime )
{
Boolean		hasEvent;

	if (mfAvail)
		hasEvent = WaitNextEvent( theEventMask, theEvent, theYieldTime, NULL );
	else
	{
		SystemTask();
		hasEvent = GetNextEvent( theEventMask, theEvent );
	}

	return hasEvent;
}


Boolean DoEvent(
	EventRecord		*theEvent )
{
WindowPtr	theWindow;
TEHandle	the_TEH;
Point		dlogOrigin;
char		theChar;
Boolean		isActive;

	switch (theEvent->what)
	{
		case mouseDown:
			DoMouseEvent( theEvent );
			break;

		case mouseUp:
			/* normally, no processing need be performed on mouseUp events */
			break;

		case keyDown:
		case autoKey:
			/* get the character value */
			theChar = (char)(theEvent->message & charCodeMask);

			/* if Command key down, then choose menu item */
			if (theEvent->modifiers & cmdKey)
				DoMenuCommand( MenuKey( theChar ) );
			break;

		case keyUp:
			/* keyUp events	normally swallowed up by OSEvent Manager, */
			/* depending on the System event mask */
			break;

		case updateEvt:
			theWindow = (WindowPtr)(theEvent->message);
			DoUpdate( theWindow );
			break;

		case diskEvt:
			/* disk inserted in a drive */
			/* only need to handle error with disk insertion */
			if (HiWord( theEvent->message ) != noErr)
			{
				SetPt(
					&dlogOrigin,
					(screenBits.bounds.right - screenBits.bounds.left) / 2 - 50,
					(screenBits.bounds.bottom - screenBits.bounds.top) / 2 - 50 );
				DIBadMount( dlogOrigin, theEvent->message ); 
			}
			break;

		case activateEvt:
			theWindow = (WindowPtr)(theEvent->message);
			isActive = (theEvent->modifiers & activeFlag);
			DoActivate( theWindow, isActive );
			break;

		case networkEvt:
			break;

		case driverEvt:
			break;

		case app1Evt:
		case app2Evt:
		case app3Evt:
			break;

		case app4Evt:
			/* MultiFinder context switch event */
			gInForeground = (theEvent->message & MASK_context_switch);
			break;

		default:
			return FALSE;
			break;
	}

	return TRUE;
}


void DoMenuCommand(
	long	theMenuInfo )
{
char			itemStr[256];
FSInfoRec		pictFileInfo;
CGrafPtr		savedPort;
GDHandle		savedGDev;
PixMapHandle	curPMHdl;
Rect			curBounds;
Point			pictSize;
GWorldFlags		curGWFlags;
OSErr			errStat;
long			newFlags;
short			theMenu, theItem, daStatus;
Boolean			isHandled = FALSE, isOn;

  	theMenu = HiWord( theMenuInfo );
	theItem = LoWord( theMenuInfo );

  	switch (theMenu)
	{
		case kMENU_apple:
			if (theItem > 1)
			{	
				GetPort( &savedPort );
				GetItem( gMenuHdlApple, theItem, itemStr );
				daStatus = OpenDeskAcc( itemStr );
				SetPort( savedPort );
			}
			break;

		case kMENU_file:
			switch (theItem)
			{
				case cITEM_open:
					curPMHdl = GWorld_GetPixMap( gWorldInfo );
					if (LockPixels( curPMHdl ))
					{
						GetGWorld( &savedPort, &savedGDev );
						SetGWorld(
							(CGrafPtr)gDemoWP, GetGWorldDevice( gWorldInfo ) );
						errStat = Open_pixel_file(
							curPMHdl, &pictSize, &pictFileInfo );

						if (errStat == noErr)
						{
							SetPort( gDemoWP );
							curBounds = gDemoWP->portRect;
							InvalRect( &curBounds );
						}

						SetGWorld( savedPort, savedGDev );
						(void)UnlockPixels( curPMHdl );

						/* disregard abort; returned if user canceled the open */
						if (errStat == abortErr)
							errStat = noErr;
						if (CheckError( errStat ))
							;
					}
					break;

				case cITEM_new:
				case cITEM_close:
				case cITEM_save:
				case cITEM_save_as:
				case cITEM_revert:
				case cITEM_page_setup:
				case cITEM_print:
					break;

				case cITEM_quit:
					gUserDone = TRUE;
					break;

				default:
					break;
			}
			break;

		case kMENU_edit:
			switch (theItem)
			{
				case cITEM_undo:
					break;

				case cITEM_cut:
				case cITEM_copy:
				case cITEM_paste:
				case cITEM_clear:
					isHandled = SystemEdit( theItem - 1 );
					break;

				case cITEM_select_all:
					break;

				default:
					break;
			}
			break;

		case kMENU_gworld_control:
			switch (theItem)
			{
				case cITEM_clear_pixels:
					curPMHdl = GWorld_GetPixMap( gWorldInfo );
					if (LockPixels( curPMHdl ))
					{
						GetGWorld( &savedPort, &savedGDev );
						SetGWorld( gWorldInfo, GetGWorldDevice( gWorldInfo ) );
						curBounds = (**curPMHdl).bounds;
						EraseRect( &curBounds );

						SetPort( gDemoWP );
						curBounds = gDemoWP->portRect;
						InvalRect( &curBounds );
						SetGWorld( savedPort, savedGDev );
						(void)UnlockPixels( curPMHdl );
					}
					break;

				case cITEM_set_pixel_depth:
					if (!DoModal_GetPixelSize( &gCurGWPixDepth ))
						break;

					curGWFlags = gwOptionFlags;
					curPMHdl = GWorld_GetPixMap( gWorldInfo );
					if (LockPixels( curPMHdl ))
					{
						GetGWorld( &savedPort, &savedGDev );
						SetGWorld( gWorldInfo, GetGWorldDevice( gWorldInfo ) );
						curBounds = (**curPMHdl).bounds;
						newFlags = UpdateGWorld(
							&gWorldInfo, gCurGWPixDepth, &curBounds,
							(CTabHandle)NULL, (GDHandle)NULL, curGWFlags );

						if ((newFlags & gwFlagErr) == 0L)
							errStat = QDError();
						else
							errStat = newFlags & ~gwFlagErr;

						SetGWorld( savedPort, savedGDev );
						(void)UnlockPixels( curPMHdl );

						if (CheckError( errStat ))
							;

						SetPort( gDemoWP );
						curBounds = gDemoWP->portRect;
						InvalRect( &curBounds );
						SetPort( savedPort );
					}
					break;

				case cITEM_dithering:
					gwOptionFlags ^= ditherPix;
					isOn = ((gwOptionFlags & ditherPix) != 0);
					CheckItem( gMenuHdl_GWorlds, cITEM_dithering, isOn );
					break;

				case cITEM_stretching:
					gwOptionFlags ^= stretchPix;	
					isOn = ((gwOptionFlags & stretchPix) != 0);
					CheckItem( gMenuHdl_GWorlds, cITEM_stretching, isOn );
					break;

				default:
					SysBeep( 1 );
					break;
			}
			break;

		case 0:
			/* no menu item selected */
			break;

		default:
			/* Oops: we dont know anything about this menu! */
			SysBeep( 1 );
			break;
	}

	HiliteMenu( 0 );
}


void DoMouseEvent(
	EventRecord		*theEvent )
{
WindowPtr		theWindow;
GrafPtr			scrPort;
ControlHandle	theControl;
Rect			windowRect;
Point			thePoint;
long			newWSize;
short			theWindowPart, theControlPart, oldCntlValue;
Boolean			hitControl;

	theWindowPart = FindWindow( theEvent->where, &theWindow );

	if ((theWindow != FrontWindow()) && (theWindow != NULL))
	{
		ShowWindow( theWindow );
		SelectWindow( theWindow );
	}
	else
	{
		switch (theWindowPart)
		{
			case inSysWindow:
		 		SystemClick( theEvent, theWindow );
				break;

			case inDesk:
				break;

			case inMenuBar:
				DoMenuCommand( MenuSelect( theEvent->where ) );
				break;

			case inContent:
				thePoint = theEvent->where;
				GlobalToLocal( &thePoint );
				theControlPart = FindControl( thePoint, theWindow, &theControl );
				switch (theControlPart)
				{
					case 0:
						/* no control part hit */
						break;

					case inButton:
						theControlPart =
							TrackControl( theControl, thePoint, (WindowPtr)(-1) );
						hitControl = (theControlPart != 0);
						if (hitControl)
							SetCtlValue( theControl, 1 - GetCtlValue( theControl ) );
						else
							theControl = NULL;
						break;

					case inCheckBox:
						theControlPart =
							TrackControl( theControl, thePoint, (WindowPtr)(-1) );
						hitControl = (theControlPart != 0);
						if (hitControl)
							SetCtlValue( theControl, 1 - GetCtlValue( theControl ) );
						else
							theControl = NULL;
						break;

					case inUpButton:
					case inDownButton:
					case inPageUp:
					case inPageDown:
					case inThumb:
						/* a scrollbar event */
						oldCntlValue = GetCtlValue( theControl );
						theControlPart =
							TrackControl( theControl, thePoint, (WindowPtr)(-1) );
						hitControl = (oldCntlValue != GetCtlValue( theControl ));

						/* process it yourself! */
						break;

					default:
						theControlPart =
							TrackControl( theControl, thePoint, (WindowPtr)(-1) );
						hitControl = (theControlPart != 0);
						if (!hitControl)
							theControl = NULL;
						break;
				}
				break;

			case inDrag:
				DragWindow( theWindow, theEvent->where, &gDragRect );
				break;

			case inGrow:
				newWSize = GrowWindow( theWindow, theEvent->where, &gGrowRect );
				if (newWSize != 0L)
				{
					SizeWindow(
						theWindow, LoWord( newWSize ), HiWord( newWSize ), TRUE );

					windowRect = theWindow->portRect;
					ClipRect( &windowRect );
					InvalRect( &windowRect );
				}
				break;

		 	case inZoomIn:
		 	case inZoomOut:
				if (TrackBox( theWindow, theEvent->where, theWindowPart ))
				{
					ZoomWindow( theWindow, theWindowPart, TRUE );
					windowRect = theWindow->portRect;
					ClipRect( &windowRect );
					InvalRect( &windowRect );
				}
		 		break;

			case inGoAway:
				if (TrackGoAway( theWindow, theEvent->where ))
					HideWindow( theWindow );
				break;
		}
	}
}


void DoActivate(
	WindowPtr	theWindow,
	Boolean		isActive )
{
	if (isActive)
	{
		SetPort( theWindow );
		/*
		TEActivate( the_TEH );
		HiliteControl( the_scrollbar, 0 );
		*/
	}
	else
	{
		/*
		TEDeactivate( the_TEH );
		HiliteControl( the_scrollbar, 255 );
		*/
	}
}


void DoUpdate(
	WindowPtr	theWindow )
{
GDHandle		savedGDev;
CGrafPtr		savedPort;
PixMapHandle	curPMHdl;
Rect			srcRect, destRect;

	if (theWindow != NULL)
	{
		GetGWorld( &savedPort, &savedGDev );
		/* SetGWorld( (CGrafPtr)theWindow, GetGWorldDevice( gWorldInfo ) ); */
		SetGWorld( (CGrafPtr)theWindow, GetMainDevice() );

		curPMHdl = GWorld_GetPixMap( gWorldInfo );
		destRect = theWindow->portRect;
		SetRect( &srcRect, 0, 0, 640, 480 );
		(void)SectRect( &srcRect, &destRect, &srcRect );

		BeginUpdate( theWindow );
			if (LockPixels( curPMHdl ))
			{
				if (curPMHdl != NULL)
					CopyBits(
						*curPMHdl, *(((CGrafPtr)theWindow)->portPixMap),
						&srcRect, &destRect, srcCopy, NULL );
				(void)UnlockPixels( curPMHdl );
			}

			/* DrawGrowIcon(); */
			/* DrawControls( theWindow ); */
		EndUpdate( theWindow );

		SetGWorld( savedPort, savedGDev );
	}
}


void StdMacInit(
	short	mpCount )
{
short	i;

	MaxApplZone();
	if (mpCount <= 0)
		mpCount = 10;
	for (i=0; i<mpCount; i++)	/* allocate enough master pointer blocks,	*/	
		MoreMasters();			/* which will hold 64 master pointers each	*/
								/* a master pointer is required for every	*/
								/* handle, which can easily be hundreds!	*/
								/* If you dont allocate them now they will	*/
								/* be automatically by the Memory Manager 	*/
								/* as needed, causing heap fragmentation	*/

	InitGraf( &thePort );		/* init QuickDraw and desktop grafPort		*/
	InitFonts();				/* init the Font Manager 					*/
	InitWindows();				/* init the Window Manager					*/
	InitMenus();				/* init the Menu Manager					*/
	TEInit();					/* init TextEdit							*/
	InitDialogs( NULL );		/* init Dialog Manager						*/

	if (SysEnvirons( 1, &gSysEnvirornInfo ) != noErr)
		;

	gMFYield = 0;
	if (gSysEnvirornInfo.machineType < 0)
		gRunningMF = FALSE;
	else								/* check for WaitNextEvent() presence */
		gRunningMF = TrapAvailable( TRAPID_WaitNextEvent );

	/* get more QuickDraw info */
	gRunningQD32 = TrapAvailable( TRAPID_BlessedQD32 );

	gDragRect = screenBits.bounds;		/* set drag rect to size of screen	*/
	gDragRect.top += GetMBarHeight();	/* adjust top for menu bar heigth	*/
	InsetRect( &gDragRect, 5, 5 );		/* walk in from edges on four sides	*/

	gGrowRect = screenBits.bounds;		/* set grow rect to size of screen	*/
	gGrowRect.top = 50;					/* set minimum size, too			*/
	gGrowRect.left = 70;

	FlushEvents( everyEvent, nullEvent );
								/* remove all pending events from queue		*/
	InitCursor();				/* set cursor to the arrow pattern			*/
}


/*
**	determines whether the given trap exists: on 64K ROM Macs, trap type is ignored.
*/
Boolean TrapAvailable(
	unsigned short	trapNumber )
{
short	theTrapType;

	theTrapType = ((trapNumber & 0x0800 != 0) ? ToolTrap : OSTrap);
	return
		(NGetTrapAddress( trapNumber, theTrapType ) !=
		GetTrapAddress( TRAPID_Unimplemented ));
}


/*
**	builds and installs the standard menus, without drawing the menubar
*/
void InstallStandardMenus(
	MenuHandle	*appleMenu,
	MenuHandle	*fileMenu,
	MenuHandle	*editMenu )
{
	if (appleMenu != NULL)
	{
		*appleMenu = NewMenu( kMENU_apple, "\p\24" );
		AppendMenu( *appleMenu, "\p(About;(-" );
		AddResMenu( *appleMenu, 'DRVR' );
		InsertMenu( *appleMenu, 0 );
	}

	if (fileMenu != NULL)
	{
		*fileMenu = NewMenu( kMENU_file, "\pFile" );
		AppendMenu( *fileMenu, "\p(New;Open/O;(-;(Close;(Save;(Save as" );
		AppendMenu( *fileMenu, "\p(Revert;(-;(Page Setup;(Print;(-;Quit/Q" );
		InsertMenu( *fileMenu, 0 );
	}

	if (editMenu != NULL)
	{
		*editMenu = NewMenu( kMENU_edit, "\pEdit" );
		AppendMenu( *editMenu, "\p(Undo/Z;(-;(Cut/X;(Copy/C;(Paste/V;(Clear" );
		AppendMenu( *editMenu, "\p(-;(Show Clipboard;(Select All" );
		InsertMenu( *editMenu, 0 );
	}
}


/*
**	minimal error reporting; via a Caution alert
*/
Boolean CheckError(
	OSErr	errStat )
{
char		strBuff[256];
GrafPtr		savedPort;
short		itemHit;

	if (errStat == noErr)
		return FALSE;

	NumToString( (long)errStat, strBuff );
	ParamText(
		"\pGeeWhiz sez ERROR: [", strBuff,
		"\p]", "\p probably a Memory Mgr complaint" );

	GetPort( &savedPort );
	itemHit = Alert( kALRT_message, NULL );
	SetPort( savedPort );

	return TRUE;
}


PixMapHandle GWorld_GetPixMap(
	GWorldPtr	theGWorld )
{
	if (theGWorld != NULL)
		return theGWorld->portPixMap;
	else
		return NULL;
}


/*
**	set new pixel value, if TRUE returned
*/
Boolean DoModal_GetPixelSize(
	short	*pixDepth )
{
char		curMainGDepthStr[16];
char		*nullStrPtr = "\p";
GDHandle	theMainGDev;
GrafPtr		savedPort;
DialogPtr	theDlogPtr;
WindowPtr	theDocWindow;
Rect		itemRect;
Handle		itemHdl;
short		itemType, curItem, itemHit;
short		curPixDepth, mainPixDepth;

	GetPort( &savedPort );
	theDlogPtr = GetNewDialog( kDLOG_SelectPixelSize, NULL, (WindowPtr)(-1) );
	if ((theDlogPtr == NULL) || (pixDepth == NULL))
		return FALSE;

	curPixDepth = *pixDepth;

	SetPort( theDlogPtr );

	theMainGDev = GetMainDevice();
	mainPixDepth = (**((**theMainGDev).gdPMap)).pixelSize;
	NumToString( (long)mainPixDepth, curMainGDepthStr );
	ParamText( curMainGDepthStr, nullStrPtr, nullStrPtr, nullStrPtr );

	if (!TrapAvailable( TRAPID_BlessedQD32 ))
	{
		if (curPixDepth > 8)
			curPixDepth = 8;

		/* disable these buttons: cannot handle 16-32 bit pixels */
		GetDItem( theDlogPtr, c16Bits, &itemType, &itemHdl, &itemRect );
		HiliteControl( (ControlHandle)itemHdl, 255 );
		GetDItem( theDlogPtr, c32Bits, &itemType, &itemHdl, &itemRect );
		HiliteControl( (ControlHandle)itemHdl, 255 );
	}

	/* set the appropriate button */
	switch (curPixDepth)
	{
		case 1:		curItem = c1Bit;	break;
		case 2:		curItem = c2Bits;	break;
		case 4:		curItem = c4Bits;	break;
		case 8:		curItem = c8Bits;	break;
		case 16:	curItem = c16Bits;	break;
		case 32:	curItem = c32Bits;	break;

		case -1:
		default:
			curItem = cMatchMainGDevice;
			break;
	}

	GetDItem( theDlogPtr, curItem, &itemType, &itemHdl, &itemRect );
	SetCtlValue( itemHdl, 1 );

	ShowWindow( (WindowPtr)theDlogPtr );

	do
	{
		ModalDialog( NULL, &itemHit );

		switch (itemHit)
		{
			case c1Bit:
			case c2Bits:
			case c4Bits:
			case c8Bits:
			case c16Bits:
			case c32Bits:
			case cMatchMainGDevice:
				if (curItem != itemHit)
				{
					GetDItem( theDlogPtr, curItem, &itemType, &itemHdl, &itemRect );
					SetCtlValue( itemHdl, 0 );
					GetDItem( theDlogPtr, itemHit, &itemType, &itemHdl, &itemRect );
					SetCtlValue( itemHdl, 1 );
					curItem = itemHit;
				}
				break;

			default:
				break;
		}
	} while (itemHit != cConfirm);

	/* pitch the dialog and restore the old cursor */
	DisposDialog( theDlogPtr );
	SetPort( savedPort );

	/*  guaranteed to be cConfirm! */
	if (itemHit == cConfirm)
	{
		switch (curItem)
		{
			case c1Bit:		*pixDepth = 1;	break;
			case c2Bits:	*pixDepth = 2;	break;
			case c4Bits:	*pixDepth = 4;	break;
			case c8Bits:	*pixDepth = 8;	break;
			case c16Bits:	*pixDepth = 16;	break;
			case c32Bits:	*pixDepth = 32;	break;

			case cMatchMainGDevice:
				*pixDepth = mainPixDepth;
				break;
	
			default:
				*pixDepth = 8;
				break;
		}
	}

	return (curItem != cMatchMainGDevice);
}