/*
	Copyright  1988,1989,1990 by Succinct Systems

	433 Huronview
	Ann Arbor, MI 48103
	(313) 663-4903

	File: 		GeeWhiz.Demo.h
	Model: 		THINK C 4.0, MPW C 3.0

	ABSTRACT:
		Demonstration program definitions, prototypes and declarations.

	NOTES:
		---

	KNOWN BUGS:
		---

	HISTORY:
		DAS 13-Apr-90	copied this from (16-Nov-89) template	(David A. Surovell)
*/

#ifndef _H_GeeWhiz_Demo_
#define _H_GeeWhiz_Demo_


#define MASK_context_switch			((long)0x00000001)

#ifndef TRAPID_Unimplemented
#define TRAPID_Unimplemented		((unsigned short)0xA89F)
#define TRAPID_WaitNextEvent		((unsigned short)0xA860)
#endif TRAPID_Unimplemented

#ifndef TRAPID_BlessedQD32
#define TRAPID_BlessedQD32			((unsigned short)0xAB03)
#endif TRAPID_BlessedQD32

#define kMENU_apple					128
typedef enum
{
	cITEM_about						= 1
} MItemsApple;

#define kMENU_file					129
typedef enum
{
	cITEM_new						= 1,
	cITEM_open						= 2,
	cITEM_close						= 4,
	cITEM_save						= 5,
	cITEM_save_as					= 6,
	cITEM_revert					= 7,
	cITEM_page_setup				= 9,
	cITEM_print						= 10,
	cITEM_quit						= 12
} MItemsFile;

#define kMENU_edit					130
typedef enum
{
	cITEM_undo						= 1,
	cITEM_cut						= 3,
	cITEM_copy						= 4,
	cITEM_paste						= 5,
	cITEM_clear						= 6,
	cITEM_select_all				= 8
} MItemsEdit;

#define kMENU_gworld_control		22222
#define kMENU_pixel_depth			22223
typedef enum
{
	cITEM_clear_pixels				= 1,
	cITEM_set_pixel_depth			= 2,
	cITEM_dithering					= 3,
	cITEM_stretching				= 4
} MItemsDemo;


typedef enum
{
	cConfirm				= 1,
	c1Bit	 				= 3,		/* Select Pixel Size dialog items */
	c2Bits	 				= 4,
	c4Bits	 				= 5,
	c8Bits 					= 6,
	c16Bits 				= 7,
	c32Bits	 				= 8,
	cMatchMainGDevice		= 9
} DItems_GetPixelSize;


#define kALRT_message				6666
#define kDLOG_SelectPixelSize		153		/* choices: 1-2-4-8-16-32 */

#define kWIND_demo					22222


extern SysEnvRec		gSysEnvirornInfo;		/* Mac OSs world, via SysEnvirons	*/
extern GWorldPtr		gWorldInfo;				/* current color world */
extern EventRecord		gMainEvent;				/* Main Event Loop information */
extern MenuHandle		gMenuHdlApple;			/* handles for standard Mac menus */
extern MenuHandle		gMenuHdlFile;
extern MenuHandle		gMenuHdlEdit;
extern MenuHandle		gMenuHdlDemo;			/* additional demo menu handles */
extern WindowPtr		gDemoWP;				/* window-related data structures */
extern WindowRecord		gDemoWR;
extern Rect				gDragRect;
extern Rect				gGrowRect;
extern Point			gLocalPt;

extern Boolean			gRunningMF;				/* is MultiFinder running */
extern Boolean			gHasEvent;				/* has appl received an event */
extern short			gMFYield;				/* yieldtime under MultiFinder */
extern Boolean			gInForeground;			/* are we MultiFinders foreground appl? */
extern Boolean			gRunningQD32;			/* QuickDraw-32 presence flag */

extern Boolean			gUserDone;



pascal OSErr main( void );

void DoPeriodicTasks(
	Boolean		inBackground );

Boolean GetEvent(
	short			theEventMask,
	EventRecord		*theEvent,
	Boolean			mfAvail,
	short			theYieldTime );

Boolean DoEvent(
	EventRecord		*theEvent );

void DoMenuCommand(
	long	theMenuInfo );

void DoMouseEvent(
	EventRecord		*theEvent );


void DoActivate(
	WindowPtr	theWindow,
	Boolean		isActive );

void DoUpdate(
	WindowPtr	theWindow );


void StdMacInit(
	short	mpCount );

Boolean TrapAvailable(
	unsigned short	theTrapWord );

void InstallStandardMenus(
	MenuHandle	*appleMenu,
	MenuHandle	*fileMenu,
	MenuHandle	*editMenu );

Boolean CheckError(
	OSErr	errStat );

Boolean DoModal_GetPixelSize(
	short	*pixDepth );

#endif _H_GeeWhiz_Demo_

