/*
	Copyright  1988,1989,1990 by
		David A. Surovell,
		Succinct Systems
		433 Huronview
		Ann Arbor, MI 48103
		(313) 663-4903
		AppleLink: (none yet)

	 All Rights Reserved. 

	File: 		VBLTasks.h
	Model: 		THINK C 4.0, MPW C 3.0, Aztec C 3.0

	ABSTRACT:
		vertical-blank task handling routines.

	NOTES:
		---

	KNOWN BUGS:
		---

	HISTORY:
		DAS	01-Jun-90	did it here first
*/

#define _H_VBLTasks

#ifndef NULL
#define NULL			0L
#endif NULL

/* tasks will be executed every VBLANK_RATE vertical blanks */
#define VBLANK_RATE		1
 
/* add more elements to this stucture if needed */
typedef struct
{
	VBLTask		vbl;
	long		A5World;
}
VBLTaskInfoRec, *VBLTaskInfoPtr;


/*
**	install generic task stub on specified GDevice:
**		task info ptr returned on success
**		NULL returned on failure
*/
VBLTaskInfoPtr InstallVBTask(
	GDHandle	theGDev );

/*
**	obtain slot number of specified GDevice
*/
unsigned short GDGetSlotID(
	GDHandle	theGDev );

/*
**	set A5 context, dispatch VBTask, refresh vbl counter
**	including additional task handler
*/
pascal void DispatchVBTask( void );

/*
**	install a routine to handle additional VB task activities:
**	must be of type "void FunctionName( void )"
*/
void SetVBHandler(
	ProcPtr		theVBHandler );

/*
**	set flag to enable a VBTask to renew itself;
**	clear to kill a running VBTask
*/
void SetVBLTaskStatus(
	Boolean		newTaskStatus );

